#ifndef NEOLAUNCHER_H_
#define NEOLAUNCHER_H_

#include "Plugin.h"
#include "ZLPlugin.h"

/* #define DEBUG_LOG */

#define VFS_NAME_LENGTH     (32)

//ݽṹ
typedef struct
{
    Boolean             isPluginEnabled;
    UInt16              cardNo;
    UInt32              type;
    UInt32              creatorId;
    LocalID             dbId;
    RectangleType       pluginRectangle;
    WChar               activeKey;//ZLZLPluginPositionType
    void                *pluginDataP;
}PluginListType;

typedef struct
{
    UInt16              cardNo;
    LocalID             dbId;
    UInt32              type;
    UInt32              creatorId;
    UInt8               categoryId;
    Char                shortcut;
    UInt16              addOnInfo;
    Char                programNameP[32];
    Char                VFSNameP[VFS_NAME_LENGTH];
}ProgramListType;

typedef struct
{
    Boolean             isCategoryHide;
    UInt8               categoryId;
    Char                nameP[16];
}CategoryType;

typedef struct
{
    Char                nameP[dmDBNameLength];
    BitmapType          *bmpIconP;
}ProgramItemInfoType;

typedef enum
{
    NOT_IN_CALL     = 0x0,
    OUTGOING_CALL   = 0x1,
    INCOMING_CALL   = 0x2
}PhoneCallStatus;

typedef struct
{
    UInt8               deviceModel;
    Boolean             shouldRelayKey;
    UInt8               isInPhone;  //0 ʾͨУ1ʾ绰2ʾ绰
    Boolean             useAsDefaultLauncher;
}NotifyParameterType;

typedef struct
{
    Char                    nameP[21];

    SoundPreference         imSoundPrefs;
    SoundPreference         phoneSoundPrefs;
    SoundPreference         emailSoundPrefs;
    SoundPreference         calendarSoundPrefs;
    SoundPreference         smsSoundPrefs;
    SoundPreference         mmsSoundPrefs;

    UInt8                   systemVolume;
    UInt8                   alertVolume;
    UInt8                   gameVolume;
    UInt8                   reserved;
}ProfileType;

typedef struct
{
    UInt8               deviceModel;
    NotifyParameterType notifyParameter;

    RGBColorType        formFrameColor;
    RGBColorType        formFillColor;
    RGBColorType        topStatusFillColor;
    RGBColorType        statusDigitalColor;
    RGBColorType        textColor;
    RGBColorType        textOutlineColor;
    RGBColorType        textOnMaskColor;
    RGBColorType        focusRingColor[6];

    Boolean             useAsDefaultLauncher;
    UInt8               ReturnToLauncherAfterCall; // 0:  1: 2: 3:ȫ

    Boolean             shouldSearchProgramWhenKeyPressed;
    Boolean             shouldEnableHoldKeyRunProgram;
    Boolean             shouldShowShortCut;
    
    Boolean             useCustomCarrier;
    Char                customCarrierP[21];
    Boolean             shouldShowDateTime;
    Boolean             shouldShowCalendar;
    Boolean             shouldAddMask;
    Boolean             shouldAddLine;
    Boolean             shouldShowTopIcons;
    Boolean             shouldShowTopPrograms;
    PatternType         maskPattern;
    UInt8               focusRingStyle;
    Boolean             shouldShowBackgd;

    Boolean             shouldSkipAllCategory;
    Boolean             shouldSkipEmptyCategory;
    Boolean             shouldSearchInGlobe;
    Boolean             shouldShowSearch;
    Boolean             shouldLaunchTheOnlyMatchedProgram;
    Boolean             shouldActivePluginInPhoneViewOnly;
    Boolean             shouldAutoRaiseProgram;
    Boolean             shouldAutoUpdateProgramList;
    Boolean             shouldDrawOutline;

    ProfileType         profiles[5];
    UInt8               lastProfile;
    Boolean             shouldEnableProfileManagement;
    WChar               ProfileActiveKey;

    Boolean             isNotificationRegistered;
    Boolean             isPhoneLibraryRegistered;

    UInt8               lastCategory;

    ProgramListType     lastProgramLaunchFromCard;
}SettingType;

//ZLӿڵչ˲creatorIdԱ㽫Prefsд롣
typedef struct
{
    ZLPluginLaunchCmdBlockType  cmdBlockType;
    UInt32                      creatorId;
    void                        *pluginDataP;   //ZLPluginData *
}ZLPluginLaunchCmdBlockTypeEx;

typedef struct
{
    ZLPluginFuncPtr                 ZLPluginFuncPtrs[ZLPluginNumFuncPtrs];
    ZLPluginLaunchCmdBlockTypeEx    cmdBlockTypeEx;
    ZLPluginLaunchCmdEventType      eventType;
    Boolean                         isPluginOpened;
}ZLPluginData;

typedef struct
{
    RectangleType       screenRectangle;
    RectangleType       backgdRectangle;
    RectangleType       statusBarRectangle;
    RectangleType       datetimeBarRectangle;
    RectangleType       launchBarRectangle;
    RectangleType       launchViewRectangle;
    RectangleType       launchViewTitleBar;
    RectangleType       launchViewStatusBar;
    RectangleType       positionRectangle[4];
    RectangleType       focusedObjectRectangle;

    BitmapType          *bmpSoundStatusP[3];
    BitmapType          *bmpBlueToothStatusP[3];
    BitmapType          *bmpPowerStatusP[2];
    BitmapType          *bmpSearchP;

    FormType            *frmPhoneUIP;
    ListType            *lstCategoryP;
    ControlType         *ptriCategoryP;
    FieldType           *fldKeywordP;
    BitmapTypeV3        *bmpBackgdP;
    BitmapTypeV3        *bmpStatusP;

//  UInt16              pmGadgetLibRef;
    UInt16              hsPhoneLibRef;
    UInt16              tonesLibRef;

    Char                operatorNameP[33];
    Char                searchKeyword[6];
    UInt8               searchKeywordNum;
    UInt32              searchKeywordTime;

    Boolean             isPopSelectEventGeneratedByKey;
//  Boolean             isGadgetActived;
    Boolean             isMenuActived;
    Boolean             isInPhoneView;
    Boolean             isInSearchMode;
    Boolean             isSearchBeginAtPhoneView;
    Boolean             isFormLoaded;
    Boolean             isHighDensitySupported;
    Boolean             isKeyDownDectected;
    Boolean             isPenDownDectected;
    Boolean             isVolumeMounted;
    WChar               holdedKey;
    UInt16              penDownObjectId;

    UInt16              focusedObjectId;
    UInt8               currentRow;
    UInt8               currentCol;
    UInt16              beginProgramInPage;
    UInt16              endProgramInPage;

    DateTimeType        justNow;

    Char                **categoryListPP;
    UInt8               *categoryListMappingP;
    UInt8               categoryCount;
    UInt8               *hideCategoryP;
    UInt8               hideCategoryCount;

    ProgramListType     *programListP;
    UInt16              programListCount;

    PluginListType      *pluginListP;
    UInt16              pluginListCount;
    PluginParameterType pluginParameter;

    WinHandle           offscreenWindowH;
    MemHandle           tinyFontH;

    Char                dateStringP[64];
    Char                timeStringP[32];

    void                *ZLFuncPtr[ZLFuncNumPtrs];

    UInt32              ticksUpdateStatusBar;

    Char                cacheP[256];
}GlobeType;

typedef struct
{
    Boolean             shouldRelayKey;
    UInt8               defaultView;
    Char                callCardPP[5][11];
}PhoneSettingType;

//ö
typedef enum
{
    PHONE_EVENT_NETWORK_SEARCHING   = sysEventFirstUserEvent + 0x0406,
    PHONE_EVENT_POWER_ON,
    PHONE_EVENT_POWER_OFF,
    PHONE_EVENT_HOME,
    PHONE_EVENT_OTHER,
    NOTIFY_EVENT_DB,
    NOTIFY_EVENT_CARD_MOUNT,
    NOTIFY_EVENT_CARD_UNMOUNT,
    NOTIFY_EVENT_WAKE_UP,
    NOTIFY_EVENT_ALERT
} CustomEventEnum;

//궨
#define APPLICATION_CREATOR                 'nLch'
#define PREFERENCE_ID                       0x00
#define PHONE_PREFERENCE_ID                 0x01
#define PREFERENCE_VERSION                  0x05
#define BITMAP_BITS_FEATURE_ID              0x01
#define NOTIFY_PARAMETER_FEATURE_ID         0x02

#define CATEGORY_LIST_DB_TYPE               'catl'
#define PROGRAM_LIST_DB_TYPE                'prgl'
#define PLUGIN_LIST_DB_TYPE                 'plgl'
#define ZL_PLUGIN_LIST_DB_TYPE              'ZLPN'
#define WALLPAPER_CACHE_NAME                "NLnchWallpaper"

#define LAUNCH_CODE_PLUGIN_ACTION           sysAppLaunchCmdCustomBase + 0x1948
#define LAUNCH_PHONE                        0x1030

#define BLAZER_CREATOR                      'BLZ5'
#define VERSAMAIL_CREATOR                   'asc3'
#define MEMO_CREATOR                        'PMem'
#define PTUNES_CREATOR                      'TNpt'
#define CONTACTS_CREATOR                    'PAdd'
#define ADDRESS_CREATOR                     'addr'
#define CALCULATOR_CREATOR                  'sciC'
#define PREF_CREATOR                        'pref'

#define TINY_FONT_ID                        128
#define TINY_FONT_RES_ID                    1000
#define TINY_FONT_RES_TYPE                  'nfnt'

#define NATIVE_WIN_ENTER_EVENT              0x0500
#define PHONE_FORM_ID_TREO600               7000
#define PHONE_FORM_ID_TREO650               7000
#define PHONE_FORM_ID_TREO680               25225
#define PHONE_FORM_OBJECT_NUMBER_TREO600    45
#define PHONE_FORM_OBJECT_NUMBER_TREO650    66
#define PHONE_FORM_OBJECT_NUMBER_TREO680    27
#define PHONE_FORM_MENUITEM_ID_TREO600      0x1C87
#define PHONE_FORM_MENUITEM_ID_TREO650      0x1C87
#define PHONE_FORM_MENUITEM_ID_TREO680      0x0066

#define NOT_A_TREO                          0x00
#define TREO_600                            0x01
#define TREO_650                            0x02
#define TREO_680                            0x03
#define CENTRO                              0x04
#define TREO_700P                           0x05
#define TREO_755P                           0x06

#define FOCUS_RING_STYLE_ROUND_RECTANGLE    0x00
#define FOCUS_RING_STYLE_SHARP_RECTANGLE    0x01
#define FOCUS_RING_STYLE_HORIZONTAL_BARS    0x02
#define FOCUS_RING_STYLE_BOTTOM_BAR         0x03
#define FOCUS_RING_STYLE_ANGLE              0x04
#define FOCUS_RING_STYLE_ROUND_FRAME        0x05
#define FOCUS_RING_STYLE_FRMAE_WITH_MASK    0x06

#define ERROR_PROGRAM_NOT_FOUND             0x0001

#define FORM_UPDATE_NO_UPDATE               0xFFFF
#define FORM_UPDATE_ALL                     0x8000
#define FORM_UPDATE_STATUS_BAR_ONLY         0x0001
#define FORM_UPDATE_LAUNCH_BAR_ONLY         0x0002
#define FORM_UPDATE_CONTENT                 0x0003
#define FORM_UPDATE_REFRESH                 0x0004

#define ICON_RESOURCE_LARGE                 1000
#define ICON_RESOURCE_SMALL                 1001

#define BUILD_LIST_MODE_INIT                0x00
#define BUILD_LIST_MODE_REFRESH             0x01
#define BUILD_LIST_MODE_ADD_DB              0x02
#define BUILD_LIST_MODE_CHANGE_DB           0x03
#define BUILD_LIST_MODE_DELETE_DB           0x04

#define PROGRAM_LIST_STATIC_MASK            0x0001

#define VIEW_MODE_PHONE                     0x00
#define VIEW_MODE_PROGRAM                   0x01

#define ALL_CATEGORIES                      0xFF
#define CARD_CATEGORY                       0xFE

#define SETTING_EXIT                        0x00
#define SETTING_GENERAL                     0x01
#define SETTING_UI                          0x02
#define SETTING_COLOR                       0x03
#define SETTING_ADVANCE                     0x04
#define SETTING_PLUGIN                      0x05

#define FOCUSED_OBJECT_NONE                 0xFFFF
#define FOCUSED_OBJECT_ICONS                0x0000

#define TABLE_COLUMN_PROGRAM_NAME           0x0000
#define TABLE_COLUMN_PROGRAM_CATEGORY       0x0001
#define TABLE_COLUMN_PROGRAM_SHORTCUT       0x0002

#define MANAGEMENT_CATEGORY_AND_SHORT_CUT   0x01
#define MANAGEMENT_CATEGORY                 0x02

#define DATE_TYPE_YEAR_MASK                 0xFE00
#define DATE_TYPE_MONTH_MASK                0x01E0
#define DATE_TYPE_DAY_MASK                  0x001F

#define STRING_DEVICE_ERROR                 "Treoϵֻϣ"
#define STRING_PHOTO_LIB_ERROR              "޷ͼƬ⣡"
#define STRING_PHONE_OFF                    "绰ر"
#define STRING_PHONE_ON                     "绰"
#define STRING_NETWORK_SEARCHING            "С"
#define STRING_SOS_CALL_ONLY                "޼ȵ绰"
#define STRING_UNFILED_CATEGORY             "δ"
#define STRING_ALL_CATEGORIER               "ȫ"
#define STRING_CARD                         "濨"
#define STRING_FOCUS_RING_COLOR_CONFIRM     "NeoLauncherΪԶ㽹Ľɫ\n"
#define STRING_REBUILD_LIST_CONFIRM         "ؽͳбɾǰķϢбָϵͳĬϵ\n"
#define STRING_LAUNCH_ERROR                 "ʧܣ"
#define STRING_SHORTCUT_CHARACTER_ERROR     "ݼAZӢĸ"
#define STRING_SHORTCUT_EXIST_ERROR         "ݼѾʹã"
#define STRING_CLEAR_SHORTCUT_CONFIRM       "ݼ\n"
#define STRING_SHORTCUT_NOT_DEFINED         "ݼδ壡\nݼڲ˵ġбж壩"
#define STRING_CALL_LOG                     "ͨ¼"
#define STRING_CONTACT_SEARCH_RESULT        ""
#define STRING_DATE_FORMAT                  "^4r.^3r.^0r "
#define STRING_WEEK_TITLE                   "","һ", "", "", "", "", ""
#define WEEK_TITLE_LENGTH                   2
#define STRING_CONFIRM_DELETE               "ȷɾѡеĳ"
#define STRING_DELETEING                    "ɾ..."
#define STRING_DELETE_COMPLETE              "ɾϣ"
#define STRING_CONFIRM_DELETE_CATEGORY      "ȷɾѡеķ"
#define STRING_CONFIRM_RESET                "ȷҪֻ"
#define STRING_CONFIRM_DELETE_PLUGIN        "ȷɾѡеĲ"
#define STRING_KEY_HOLD_TIP                 "ͷŰ..."
#define STRING_FOCUS_RING_STYLE_NO_SUPPORT  "Treo600ֽ֧ʽ"
#define STRING_PROFILE_NORMAL               "׼"
#define STRING_PROFILE_UNDEFINE             "δ"
#define STRING_TONES_LIBRARY_ERROR          ""
#define STRING_ALERT_MANAGER                "µϢ"
/*
#define STRING_DEVICE_ERROR                 "This program supports Treo series only!"
#define STRING_PHOTO_LIB_ERROR              "Can't load Photo Library!"
#define STRING_PHONE_OFF                    "Phone Off"
#define STRING_PHONE_ON                     "Phone On"
#define STRING_NETWORK_SEARCHING            "Network Search..."
#define STRING_SOS_CALL_ONLY                "SOS Call Only"
#define STRING_UNFILED_CATEGORY             "Unfiled"
#define STRING_ALL_CATEGORIER               "All"
#define STRING_CARD                         "Storage Card"
#define STRING_FOCUS_RING_COLOR_CONFIRM     "NeoLauncher can calculate the rest ring color automatically\nDo you want to continue?"
#define STRING_REBUILD_LIST_CONFIRM         "The category and program list will be delete and restore to the system default!\nAre you sure to continue?"
#define STRING_LAUNCH_ERROR                 "Launch failed!"
#define STRING_SHORTCUT_ERROR               "Shortcut must be the character from A-Z!"
#define STRING_SHORTCUT_EXIST_ERROR         "Shortcut exist!"
#define STRING_CLEAR_SHORTCUT_CONFIRM       "Shortcut will be delete!\nDo you want to continue?"
#define STRING_SHORTCUT_NOT_DEFINED         "Shortcut is not defined!\n(Shortcut can be defined in menu 'Category & Shortcut')"
#define STRING_CALL_LOG                     "Call Log"
#define STRING_CONTACT_SEARCH_RESULT        "Matched"
#define STRING_DATE_FORMAT                  "^1r, ^2r ^0s, ^4r"
#define STRING_WEEK_TITLE                   "S", "M", "T", "W", "T", "F", "S"
#define WEEK_TITLE_LENGTH                   1
#define STRING_CONFIRM_DELETE               "Are you sure to delete the selected program?"
#define STRING_DELETEING                    "Deleting..."
#define STRING_DELETE_COMPLETE              "Program deleted!"
#define STRING_CONFIRM_DELETE_CATEGORY      "Are you sure to delete the selected category?"
#define STRING_CONFIRM_RESET                "Are you sure to reset your phone?"
#define STRING_CONFIRM_DELETE_PLUGIN        "Are you sure to delete the selected plugin?"
#define STRING_KEY_HOLD_TIP                 "Release key to launch program..."
#define STRING_FOCUS_RING_STYLE_NO_SUPPORT  "The selected focus ring style is not supported by Treo 600."
#define STRING_PROFILE_NORMAL               "Normal"
#define STRING_PROFILE_UNDEFINE             "Undefine"
#define STRING_TONES_LIBRARY_ERROR          "Error when loading Tones Library."
#define STRING_ALERT_MANAGER                "You have new messages"
*/

#define GET_OBJECT_POINTER(f, o)            FrmGetObjectPtr(f, FrmGetObjectIndex(f, o))

#endif
