#include "NongLi.h"

const   char   sTG[][3]=   {"","","","","","","","","",""};
const   char   sDZ[][3]=   {"","","","î","","","","δ","","","",""};
const   char   sSX[][3]=   {"","ţ","","","","","","","","","",""};
const   char   sMon[][3]=   {"","","","","","","","","","ʮ","",""};
const   char   sDate[][5]=   {
      "һ","","","","","","","","","ʮ",
      "ʮһ","ʮ","ʮ","ʮ","ʮ","ʮ","ʮ","ʮ","ʮ","ʮ",
      "إһ","إ","إ","إ","إ","إ","إ","إ","إ","ʮ"
};

const UInt32   dwCalendarData[]=
{
      0xc96,    0x41a95,    0xd4a,  0xda5,  0x20b55,
      0x56a,    0x7155b,    0x25d,  0x92d,  0x5192b,
      0xa95,    0xb4a,      0x416aa,0xad5,  0x90ab5,
      0x4ba,    0xa5b,      0x60a57,0x52b,  0xa93,0x40e59
};

/**************************************************
sLunar:   ַ
dwDays:   ھ   2000/02/05
**************************************************/
Boolean solar2Lunar(LunarDateType *lunarDateType, UInt32 dwDays)
{

    //   Start   from   2000/2/5,   20   Lunar   years'   Data
    const UInt32 dwLunarYears = 20;
    UInt32   i, j;
    UInt32   yy = 0, mm = 0;
    UInt32   tmp, runyue,  month, sum=0, days;

    for (i = 0; i < dwLunarYears; i++)
    {
        tmp = dwCalendarData[i];
        runyue = (tmp >> 16) & 0x0f;        //Ƿ
        month = (runyue ==0 ) ? 12 : 13;                //ܹм
        for (j = 0; j < month; j++)
        {
            days = ((tmp >> ( month - j - 1)) & 1) == 0 ? 29 : 30;  //ж
            if (sum + days > dwDays)
                break;
            sum += days;
        }
        if (j < month)
            break;
    }
    //ʱ̫
    if (i == dwLunarYears)
    {
        return false;
    }

    StrCopy(lunarDateType->year, sTG[(i + 6) % 10]);
    StrCat(lunarDateType->year, sDZ[(i + 4) % 12]);
    StrCopy(lunarDateType->shuxing, sSX[(i + 4) % 12]);
    StrCopy(lunarDateType->month, sMon[((runyue !=0) && (j > runyue - 1)) ? j - 1 : j]);
    StrCopy(lunarDateType->day, sDate[dwDays-sum]);

    if((runyue != 0)  &&  (j == runyue))
        lunarDateType->runyue=true;
    else
        lunarDateType->runyue=false;

    return true;
}
