#include <PalmOS.h>
#include <HsKeyCodes.h>
#include <68K\Hs.h>
#include <68K\libraries\imaging\PalmOnePhoto.h>

#include "NeoLauncher.h"
#include "NeoLauncher_Rsc.h"
#include "Setup.h"

//źŷ
WinLineType signalOnly[SIGNAL_ONLY_LENGTH] = {{262, 1, 275, 1}, {262, 2, 275, 2}, {263, 3, 264, 3}, {273, 3, 274, 3},
    {264, 4, 265, 4}, {272, 4, 273, 4}, {265, 5, 266, 5}, {271, 5, 272, 5}, {266, 6, 271, 6},
    {267, 7, 270, 7}, {268, 3, 268, 23}, {269, 3, 269, 23}};

//źǿ
WinLineType signalLevel[4][SIGNAL_LEVEL_LENGTH] = {{{272, 21, 272, 23}, {273, 21, 273, 23}, {274, 21, 274, 23}}, {{276, 17, 276, 23},
    {277, 17, 277, 23}, {278, 17, 278, 23}}, {{280, 13, 280, 23}, {281, 13, 281, 23}, {282, 13, 282, 23}},
    {{284, 9, 284, 23}, {285, 9, 285, 23}, {286, 9, 286, 23}}};

//ݱ־
WinLineType signalData[SIGNAL_DATA_LENGTH] = {{276, 5, 283, 5}, {276, 6, 282, 6}, {276, 7, 281, 7}, {276, 8, 280, 8},
    {276, 9, 279, 9}, {276, 10, 278, 10}, {276, 11, 277, 11}, {276, 12, 276, 12}};

//
WinLineType signalConnection[SIGNAL_CONNECTION_LENGTH] = {{281, 2, 281, 2}, {281, 3, 282, 3}, {281, 4, 283, 4}, {277, 5, 284, 5},
    {277, 6, 285, 6}, {273, 9, 281, 9}, {274, 10, 281, 10}, {275, 11, 277, 11}, {276, 12, 277, 12},
    {277, 13, 277, 13}};

//
WinLineType batteryShape[BATTERY_SHAPE_LENGTH] = {{308, 1, 312, 1}, {307, 2, 308, 2}, {312, 2, 313, 2}, {306, 3, 308, 3}, {312, 3, 314, 3},
    {305, 4, 305, 22}, {315, 4, 315, 22}, {306, 23, 314, 23}};

static UInt8 frmGeneralSettingHandler(SettingType *settingP, GlobeType *globeP);
static UInt8 frmPluginSettingHandler(SettingType *settingP, GlobeType *globeP);
static UInt8 frmAdvanceSettingHandler(SettingType *settingP, GlobeType *globeP);
static UInt8 frmColorSettingHandler(SettingType *settingP, GlobeType *globeP);
static UInt8 frmUISettingHandler(SettingType *settingP, GlobeType *globeP);

#if 0
#pragma mark -
#pragma mark SETTING FUNCTIONS
#pragma mark -
#endif

#if 0
#pragma mark == SETTING COMMON FUNCTIONS ==
#endif


//עϢ
void notifyUnregister(SettingType *settingP/*Boolean shouldSetVirtualCharHandlingNotify*/)
{
    UInt16                  cardNo;
    LocalID                 dbId;
    NotifyParameterType     *notifyParameterP;

    SysCurAppDatabase(&cardNo, &dbId);

    //SysNotifyUnregister(cardNo, dbId, sysNotifyDBCreatedEvent, sysNotifyNormalPriority);
    //SysNotifyUnregister(cardNo, dbId, sysNotifyDBChangedEvent, sysNotifyNormalPriority);
    //SysNotifyUnregister(cardNo, dbId, sysNotifyDBDeletedEvent, sysNotifyNormalPriority);
    //SysNotifyUnregister(cardNo, dbId, sysNotifyCardInsertedEvent, sysNotifyNormalPriority);
    //SysNotifyUnregister(cardNo, dbId, sysNotifyCardRemovedEvent, sysNotifyNormalPriority);
    SysNotifyUnregister(cardNo, dbId, sysNotifyVolumeMountedEvent, sysNotifyNormalPriority);
    SysNotifyUnregister(cardNo, dbId, sysNotifyVolumeUnmountedEvent, sysNotifyNormalPriority);
    SysNotifyUnregister(cardNo, dbId, sysNotifyLateWakeupEvent, sysNotifyNormalPriority);
    SysNotifyUnregister(cardNo, dbId, sysNotifyVirtualCharHandlingEvent, sysNotifyNormalPriority);

    if (FtrGet(APPLICATION_CREATOR, NOTIFY_PARAMETER_FEATURE_ID, (UInt32 *)&notifyParameterP) != errNone)
    {
        FtrPtrFree(APPLICATION_CREATOR, NOTIFY_PARAMETER_FEATURE_ID);
    }

    settingP->isNotificationRegistered = false;
}

//עϢ
void notifyRegister(SettingType *settingP/*, Boolean shouldSetVirtualCharHandlingNotify*/)
{
    UInt16                  cardNo;
    LocalID                 dbId;
    PhoneSettingType        phoneSetting;
    NotifyParameterType     *notifyParameterP;
    NotifyParameterType     tmpNotifyParameter;
    UInt16                  phoneSettingSize    = sizeof(PhoneSettingType);

    SysCurAppDatabase(&cardNo, &dbId);

    //SysNotifyRegister(cardNo, dbId, sysNotifyDBCreatedEvent, NULL, sysNotifyNormalPriority, NULL);
    //SysNotifyRegister(cardNo, dbId, sysNotifyDBChangedEvent, NULL, sysNotifyNormalPriority, NULL);
    //SysNotifyRegister(cardNo, dbId, sysNotifyDBDeletedEvent, NULL, sysNotifyNormalPriority, NULL);
    SysNotifyRegister(cardNo, dbId, sysNotifyVolumeMountedEvent, NULL, sysNotifyNormalPriority, NULL);
    SysNotifyRegister(cardNo, dbId, sysNotifyVolumeUnmountedEvent, NULL, sysNotifyNormalPriority, NULL);
    SysNotifyRegister(cardNo, dbId, sysNotifyLateWakeupEvent, NULL, sysNotifyNormalPriority, NULL);

    if (FtrGet(APPLICATION_CREATOR, NOTIFY_PARAMETER_FEATURE_ID, (UInt32 *)&notifyParameterP) != errNone)
    {
        FtrPtrNew(APPLICATION_CREATOR, NOTIFY_PARAMETER_FEATURE_ID, sizeof(NotifyParameterType), (void **)&notifyParameterP);
    }

    if (PrefGetAppPreferences(APPLICATION_CREATOR, PHONE_PREFERENCE_ID, &phoneSetting, &phoneSettingSize, true) != noPreferenceFound)
    {
        tmpNotifyParameter.shouldRelayKey = phoneSetting.shouldRelayKey;
    }
    else
    {
        tmpNotifyParameter.shouldRelayKey = false;
    }

    tmpNotifyParameter.isInPhone = NOT_IN_CALL;
    tmpNotifyParameter.deviceModel = settingP->deviceModel;
    tmpNotifyParameter.useAsDefaultLauncher = settingP->useAsDefaultLauncher;

    DmWrite(notifyParameterP, 0, &tmpNotifyParameter, sizeof(NotifyParameterType));

    SysNotifyRegister(cardNo, dbId, sysNotifyVirtualCharHandlingEvent, NULL, sysNotifyNormalPriority, notifyParameterP);

    settingP->isNotificationRegistered = false;
}

//ɫͬȵĻɫ
void getGrayColor(RGBColorType *grayColor, RGBColorType *originalColor)
{
    UInt32      y   = (((UInt32)originalColor->r) * 299 + ((UInt32)originalColor->g) * 587 + ((UInt32)originalColor->b) * 114) / 1000;

    if (y < 204)
    {
        y = 204;
    }
    grayColor->r = y; grayColor->g = y; grayColor->b = y;
}

//㷴תɫ
void getInvertColor(RGBColorType *invertColor, RGBColorType *originalColor)
{
    UInt32      x   = ((UInt32)originalColor->r) * 299 + ((UInt32)originalColor->g) * 587 + ((UInt32)originalColor->b) * 114;
    if (((UInt32)originalColor->r) * 299 + ((UInt32)originalColor->g) * 587 + ((UInt32)originalColor->b) * 114 > 204000/*127000*/)  //
    {
        invertColor->r = 0;
        invertColor->g = 0;
        invertColor->b = 0;
    }
    else
    {
        invertColor->r = 255;
        invertColor->g = 255;
        invertColor->b = 255;
    }
}

//Ĭɫ
void getDefaultColor(SettingType *settingP)
{
    UInt16      i;

    UIColorGetTableEntryRGB(UIFormFrame, &settingP->formFrameColor);
    UIColorGetTableEntryRGB(UIFormFill, &settingP->formFillColor);
    UIColorGetTableEntryRGB(UIObjectForeground, &settingP->textColor);
    UIColorGetTableEntryRGB(UIFormFill, &settingP->textOutlineColor);
    UIColorGetTableEntryRGB(UIObjectForeground, &settingP->statusDigitalColor);
    getInvertColor(&settingP->textOnMaskColor, &settingP->formFrameColor);
    settingP->topStatusFillColor = settingP->formFillColor;
    settingP->focusRingColor[0].r = 0; settingP->focusRingColor[0].g = 51; settingP->focusRingColor[0].b = 204;
    settingP->focusRingColor[1].r = 0; settingP->focusRingColor[1].g = 102; settingP->focusRingColor[1].b = 255;
    settingP->focusRingColor[2].r = 51; settingP->focusRingColor[2].g = 153; settingP->focusRingColor[2].b = 255;
    settingP->focusRingColor[3].r = 102; settingP->focusRingColor[3].g = 204; settingP->focusRingColor[3].b = 255;
    settingP->focusRingColor[4].r = 153; settingP->focusRingColor[4].g = 255; settingP->focusRingColor[4].b = 255;
    settingP->focusRingColor[5].r = 204; settingP->focusRingColor[5].g = 255; settingP->focusRingColor[5].b = 255;
    for (i = hsNavFocusColorRing1; i <= hsNavFocusColorRing6; i ++)
    {
        HsNavSetFocusColor(i, &settingP->focusRingColor[i - hsNavFocusColorRing1], NULL);
    }
}

//Զ尴
WChar customKey()
{
    FormType    *frmP;
    EventType   event;
    WChar       key     = chrNull;

    FrmPopupForm(frmSetKeyTips);

    do
    {
        EvtGetEvent(&event, evtWaitForever);

        if (event.eType == keyUpEvent)
        {
            if (event.data.keyDown.keyCode != 0)
            {
                key = (WChar)event.data.keyDown.keyCode;
            }
            else
            {
                key = (WChar)event.data.keyDown.chr;
            }
        }
        else if (event.eType == keyDownEvent && (! (event.data.keyDown.modifiers & 0x0008)))
        {
            key = event.data.keyDown.chr;
        }

        if (key == chrNull && (event.eType != keyUpEvent && event.eType != keyDownEvent))
        {
            if (! SysHandleEvent(&event))
            {
                if (event.eType == frmLoadEvent && event.data.frmLoad.formID == frmSetKeyTips)
                {
                    frmP = FrmInitForm(frmSetKeyTips);
                    FrmSetActiveForm(frmP);
                }
                else if (event.eType == frmOpenEvent && event.data.frmOpen.formID == frmSetKeyTips)
                {
                    FrmDrawForm(frmP);
                }
                else
                {
                    FrmDispatchEvent(&event);
                }
            }
        }
    }while (key == chrNull && event.eType != appStopEvent);

    //˳
    FrmReturnToForm(0);

    return key;
}

//ֵת
WChar keyTransfer(WChar chr, UInt16 keyCode, UInt16 modifiers)
{
    if (modifiers & 0x0008)
    {
        if (keyCode != 0)
        {
            return (WChar)keyCode;
        }
        else
        {
            return chr;
        }
    }
    else
    {
        return chr;
    }
}

//ͷŲб
void freePluginList(PluginListType *pluginListP, UInt16 pluginListCount)
{
    UInt16      i;

    for (i = 0; i < pluginListCount; i ++)
    {
        if (pluginListP[i].pluginDataP != NULL)
        {
            if (pluginListP[i].type == ZL_PLUGIN_LIST_DB_TYPE)
            {
                ZLPluginData *dataP = pluginListP[i].pluginDataP;

                if (dataP->isPluginOpened)
                {
                    UInt32  result;

                    SysAppLaunch(pluginListP[i].cardNo, pluginListP[i].dbId, 0, sysAppLaunchCmdZLPluginLoad, dataP->ZLPluginFuncPtrs, &result);
                    if (result == errNone)
                        dataP->ZLPluginFuncPtrs[ZLPluginFuncPtrClose]((ZLPluginLaunchCmdBlockType *)&(dataP->cmdBlockTypeEx));
                }
                if (dataP->cmdBlockTypeEx.cmdBlockType.dbP != NULL)
                {
                    DmCloseDatabase(dataP->cmdBlockTypeEx.cmdBlockType.dbP);
                }
            }
            MemPtrFree(pluginListP[i].pluginDataP);
        }
    }
    if (pluginListP != NULL)
        MemPtrFree(pluginListP);
}

//ȡб
void getPluginList(PluginListType **pluginListPP, UInt16 *pluginListCount, Boolean isActivedOnly, GlobeType *globeP)
{
    UInt16              i;
    DmSearchStateType   searchState;
    MemHandle           recordH;
    PluginListType      *recordP;
    UInt16              recordNums;
    DmOpenRef           dbRef   = DmOpenDatabaseByTypeCreator(PLUGIN_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadOnly);

    if (DmGetLastErr() != errNone)
    {
        DmCreateDatabase(0, "Plugin List", APPLICATION_CREATOR, PLUGIN_LIST_DB_TYPE, false);
        dbRef = DmOpenDatabaseByTypeCreator(PLUGIN_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadOnly);
    }

    recordNums = DmNumRecordsInCategory(dbRef, dmAllCategories);
    (*pluginListPP) = (PluginListType *)MemPtrNew(sizeof(PluginListType) * (recordNums + 1));
    (*pluginListCount) = 0;

    for (i = 0; i < recordNums; i ++)
    {
        recordH = DmQueryRecord(dbRef, i);
        recordP = (PluginListType *)MemHandleLock(recordH);

        if ((recordP->isPluginEnabled && isActivedOnly) || (! isActivedOnly))
        {
            (*pluginListPP)[(*pluginListCount)] = (*recordP);
            (*pluginListPP)[(*pluginListCount)].pluginDataP = NULL;

            if (DmGetNextDatabaseByTypeCreator(true, &searchState, recordP->type, recordP->creatorId, true, &(*pluginListPP)[(*pluginListCount)].cardNo, &(*pluginListPP)[(*pluginListCount)].dbId) == errNone)
            {
                if (recordP->isPluginEnabled && isActivedOnly && recordP->type == ZL_PLUGIN_LIST_DB_TYPE)
                {
                    ZLPluginData *dataP = MemPtrNew(sizeof(ZLPluginData));

                    (*pluginListPP)[(*pluginListCount)].pluginDataP = (void *)dataP;

                    if (dataP != NULL)
                    {
                        UInt32  result;

                        dataP->cmdBlockTypeEx.cmdBlockType.dbP = NULL;
                        dataP->isPluginOpened = false;

                        SysAppLaunch((*pluginListPP)[(*pluginListCount)].cardNo, (*pluginListPP)[(*pluginListCount)].dbId, 0, sysAppLaunchCmdZLPluginLoad, dataP->ZLPluginFuncPtrs, &result);
                        if (result == errNone)
                        {
                            dataP->cmdBlockTypeEx.creatorId = recordP->creatorId;
                            dataP->cmdBlockTypeEx.pluginDataP = (void *)dataP;
                            dataP->cmdBlockTypeEx.cmdBlockType.pZLFuncPtrs = globeP->ZLFuncPtr;
                            dataP->cmdBlockTypeEx.cmdBlockType.position = recordP->activeKey;
                            dataP->cmdBlockTypeEx.cmdBlockType.panelType = ZLPluginPanelTop;
                            dataP->cmdBlockTypeEx.cmdBlockType.lefty = false;
                            dataP->cmdBlockTypeEx.cmdBlockType.pluginMgrVerNum = ZLPluginMgrVerNum;
                            dataP->cmdBlockTypeEx.cmdBlockType.ZLPluginPanelWidth = recordP->pluginRectangle.extent.x;
                            dataP->cmdBlockTypeEx.cmdBlockType.ZLPluginPanelHeight = recordP->pluginRectangle.extent.y;
                            dataP->cmdBlockTypeEx.cmdBlockType.bounds = recordP->pluginRectangle;
                                //UIͬĴС
                            dataP->cmdBlockTypeEx.cmdBlockType.clipBounds.topLeft.x = 0;
                            dataP->cmdBlockTypeEx.cmdBlockType.clipBounds.topLeft.y = 0;
                            dataP->cmdBlockTypeEx.cmdBlockType.clipBounds.extent.x = 160;
                            dataP->cmdBlockTypeEx.cmdBlockType.clipBounds.extent.y = 160;

                            dataP->cmdBlockTypeEx.cmdBlockType.dbP = DmOpenDatabase((*pluginListPP)[(*pluginListCount)].cardNo, (*pluginListPP)[(*pluginListCount)].dbId, dmModeReadOnly);
                            if (dataP->cmdBlockTypeEx.cmdBlockType.dbP)
                            {
                                result = dataP->ZLPluginFuncPtrs[ZLPluginFuncPtrOpen]((ZLPluginLaunchCmdBlockType *)&(dataP->cmdBlockTypeEx));
                                if (result == errNone)
                                {
                                    dataP->isPluginOpened = true;
                                }
                            }
                        }
                    }
                }

                (*pluginListCount) ++;
            }
        }
        MemHandleUnlock(recordH);
    }

    DmCloseDatabase(dbRef);
}

#if 0
#pragma mark == SETTING FORM FUNCTIONS ==
#endif

//ýл
/*static */void showSettingUI(SettingType *settingP, GlobeType *globeP)
{
    UInt8       i   = SETTING_GENERAL;

    //ȡϢע
    notifyUnregister(settingP);

    do
    {
        switch (i)
        {
            case SETTING_GENERAL:
                i = frmGeneralSettingHandler(settingP, globeP);
                break;
            case SETTING_UI:
                i = frmUISettingHandler(settingP, globeP);
                break;
            case SETTING_COLOR:
                i = frmColorSettingHandler(settingP, globeP);
                break;
            case SETTING_ADVANCE:
                i = frmAdvanceSettingHandler(settingP, globeP);
                break;
            case SETTING_PLUGIN:
                //ԤɾбԱй
                freePluginList(globeP->pluginListP, globeP->pluginListCount);

                i = frmPluginSettingHandler(settingP, globeP);

                //ˢ²б
                getPluginList(&globeP->pluginListP, &globeP->pluginListCount, true, globeP);
                break;
        }
    }while (i != SETTING_EXIT);

    if (settingP->shouldAddMask)
    {
        globeP->pluginParameter.defaultDisplayEffect = DISPLAY_EFFECT_ADD_MASK;
    }
    else if (settingP->shouldAddLine)
    {
        globeP->pluginParameter.defaultDisplayEffect = DISPLAY_EFFECT_ADD_LINE;
    }
    else
    {
        globeP->pluginParameter.defaultDisplayEffect = DISPLAY_EFFECT_NONE;
    }
    globeP->pluginParameter.defaultMaskPattern = settingP->maskPattern;
    globeP->pluginParameter.textColor = settingP->textColor;
    globeP->pluginParameter.textOutlineColor = settingP->textOutlineColor;
    globeP->pluginParameter.foreColor = settingP->formFrameColor;
    globeP->pluginParameter.backgdColor = settingP->formFillColor;

    //עϢ
    notifyRegister(settingP);
}

#if 0
#pragma mark -----------------------------------------------------
#endif

//绰Ƿ
static Boolean IsPhonePluginExist()
{
    UInt16              i;
    MemHandle           recordH;
    PluginListType      *recordP;
    DmOpenRef           dbRef   = DmOpenDatabaseByTypeCreator(PLUGIN_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadOnly);
    UInt16              recordNum   = DmNumRecordsInCategory(dbRef, dmAllCategories);

    for (i = 0; i < recordNum; i ++)
    {
        recordH = DmQueryRecord(dbRef, i);
        recordP = (PluginListType *)MemHandleLock(recordH);
        if (recordP->type == 'NlPh' && recordP->isPluginEnabled)
        {
            MemHandleUnlock(recordH);
            DmCloseDatabase(dbRef);
            return true;
        }
        MemHandleUnlock(recordH);
    }
    DmCloseDatabase(dbRef);

    return false;
}

//ô
static UInt8 frmGeneralSettingHandler(SettingType *settingP, GlobeType *globeP)
{
    FormType        *frmGeneralSettingP;
    ControlType     *cbSetAsDefaultLauncherP;
    ControlType     *cbReturnAfterOutCallP;
    ControlType     *cbReturnAfterInCallP;
    ControlType     *cbSearchProgramWhenKeyPressP;
    ControlType     *cbDialWhenKeyPressP;
    ControlType     *cbEnableHoldKeyRunProgramP;
    ControlType     *cbShouldShowShortCutP;
    ControlType     *cbEnableProfileManagementP;
    ControlType     *btnProfileManagementSettingP;
    ControlType     *btnProfileManagementKeyP;
    ControlType     *btnProfileManagementKeyClearP;
    EventType       event;
    Boolean         isEventHandled;
    Boolean         isPhonePluginExist;
    Boolean         shouldExit          = false;
    UInt8           returnCode          = SETTING_EXIT;

    FrmPopupForm(frmGeneralSetting);

    do
    {
        EvtGetEvent(&event, evtWaitForever);

        if (! SysHandleEvent(&event))
        {
            isEventHandled = false;

            switch (event.eType)
            {
                case frmLoadEvent:
                    if (event.data.frmLoad.formID == frmGeneralSetting)
                    {
                        frmGeneralSettingP = FrmInitForm(frmGeneralSetting);
                        cbSetAsDefaultLauncherP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, cbSetAsDefaultLauncher);
                        cbReturnAfterOutCallP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, cbReturnAfterOutCall);
                        cbReturnAfterInCallP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, cbReturnAfterInCall);
                        cbSearchProgramWhenKeyPressP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, cbSearchProgramWhenKeyPress);
                        cbDialWhenKeyPressP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, cbDialWhenKeyPress);
                        cbEnableHoldKeyRunProgramP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, cbEnableHoldKeyRunProgram);
                        cbShouldShowShortCutP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, cbShouldShowShortCut);
                        cbEnableProfileManagementP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, cbEnableProfileManagement);
                        btnProfileManagementSettingP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, btnProfileManagementSetting);
                        btnProfileManagementKeyP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, btnProfileManagementKey);
                        btnProfileManagementKeyClearP = (ControlType *)GET_OBJECT_POINTER(frmGeneralSettingP, btnProfileManagementKeyClear);
                        FrmSetActiveForm(frmGeneralSettingP);
                        isEventHandled = true;
                    }
                    break;
                case frmOpenEvent:
                    if (event.data.frmOpen.formID == frmGeneralSetting)
                    {
                        //
                        FrmDrawForm(frmGeneralSettingP);

                        //ÿؼ
                        FrmSetControlValue(frmGeneralSettingP, FrmGetObjectIndex(frmGeneralSettingP, pbtnGeneralSetting1), 1);
                        CtlSetValue(cbSetAsDefaultLauncherP, settingP->useAsDefaultLauncher);

                        if (settingP->useAsDefaultLauncher)
                        {
                            CtlShowControl(cbReturnAfterOutCallP);
                            CtlShowControl(cbReturnAfterInCallP);

                            if ((settingP->ReturnToLauncherAfterCall & OUTGOING_CALL) != 0)
                            {
                                CtlSetValue(cbReturnAfterOutCallP, 1);
                            }

                            if ((settingP->ReturnToLauncherAfterCall & INCOMING_CALL) != 0)
                            {
                                CtlSetValue(cbReturnAfterInCallP, 1);
                            }
                        }
                        else
                        {
                            CtlHideControl(cbReturnAfterOutCallP);
                            CtlHideControl(cbReturnAfterInCallP);
                        }
                        
                        if (settingP->shouldEnableHoldKeyRunProgram)
                        {
                            CtlSetValue(cbEnableHoldKeyRunProgramP, 1);
                        }
                        else
                        {
                            CtlSetValue(cbEnableHoldKeyRunProgramP, 0);
                        }
                        
                        if (settingP->shouldShowShortCut)
                        {
                            CtlSetValue(cbShouldShowShortCutP, 1);
                        }
                        else
                        {
                            CtlSetValue(cbShouldShowShortCutP, 0);
                        }

                        if (settingP->shouldEnableProfileManagement)
                        {
                            CtlSetValue(cbEnableProfileManagementP, 1);
                            CtlShowControl(btnProfileManagementSettingP);
                            CtlShowControl(btnProfileManagementKeyP);
                            CtlShowControl(btnProfileManagementKeyClearP);
                        }
                        else
                        {
                            CtlHideControl(btnProfileManagementSettingP);
                            CtlHideControl(btnProfileManagementKeyP);
                            CtlHideControl(btnProfileManagementKeyClearP);
                        }

                        isPhonePluginExist = IsPhonePluginExist();
                        if (settingP->shouldSearchProgramWhenKeyPressed)
                        {
                            CtlSetValue(cbSearchProgramWhenKeyPressP, 1);
                        }
                        else
                        {
                            if (isPhonePluginExist)
                            {
                                CtlSetValue(cbDialWhenKeyPressP, 1);
                            }
                            else
                            {
                                CtlSetValue(cbSearchProgramWhenKeyPressP, 1);
                            }
                        }

                        if (! isPhonePluginExist)
                        {
                            CtlHideControl(cbDialWhenKeyPressP);
                        }

                        //
                        HsNavObjectTakeFocus(frmGeneralSettingP, pbtnGeneralSetting1);
                        isEventHandled = true;
                    }
                    break;
                case ctlSelectEvent:
                    switch (event.data.ctlSelect.controlID)
                    {
                        case btnGeneralOK:
                            shouldExit = true;
                            returnCode = SETTING_EXIT;
                            isEventHandled = true;
                            break;
                        case pbtnUISetting1:
                            shouldExit = true;
                            returnCode = SETTING_UI;
                            isEventHandled = true;
                            break;
                        case pbtnColorSetting1:
                            shouldExit = true;
                            returnCode = SETTING_COLOR;
                            isEventHandled = true;
                            break;
                        case pbtnAdvanceSetting1:
                            shouldExit = true;
                            returnCode = SETTING_ADVANCE;
                            isEventHandled = true;
                            break;
                        case pbtnPluginSetting1:
                            shouldExit = true;
                            returnCode = SETTING_PLUGIN;
                            isEventHandled = true;
                            break;
                        case cbSearchProgramWhenKeyPress:
                            if (CtlGetValue(cbSearchProgramWhenKeyPressP) && isPhonePluginExist)
                            {
                                CtlSetValue(cbDialWhenKeyPressP, 0);
                            }
                            else
                            {
                                CtlSetValue(cbDialWhenKeyPressP, 1);
                            }
                            break;
                        case cbDialWhenKeyPress:
                            if (CtlGetValue(cbDialWhenKeyPressP))
                            {
                                CtlSetValue(cbSearchProgramWhenKeyPressP, 0);
                            }
                            else
                            {
                                CtlSetValue(cbSearchProgramWhenKeyPressP, 1);
                            }
                            break;
                        case cbSetAsDefaultLauncher:
                            if (CtlGetValue(cbSetAsDefaultLauncherP))
                            {
                                CtlShowControl(cbReturnAfterOutCallP);
                                CtlShowControl(cbReturnAfterInCallP);
                            }
                            else
                            {
                                settingP->ReturnToLauncherAfterCall = 0;
                                CtlSetValue(cbReturnAfterOutCallP, 0);
                                CtlSetValue(cbReturnAfterInCallP, 0);
                                CtlHideControl(cbReturnAfterOutCallP);
                                CtlHideControl(cbReturnAfterInCallP);
                            }
                            break;
                        case cbEnableProfileManagement:
                            if (CtlGetValue(cbEnableProfileManagementP))
                            {
                                CtlShowControl(btnProfileManagementSettingP);
                                CtlShowControl(btnProfileManagementKeyP);
                                CtlShowControl(btnProfileManagementKeyClearP);
                            }
                            else
                            {
                                CtlHideControl(btnProfileManagementSettingP);
                                CtlHideControl(btnProfileManagementKeyP);
                                CtlHideControl(btnProfileManagementKeyClearP);
                            }
                            break;
                        case cbEnableHoldKeyRunProgram:
                            if (CtlGetValue(cbEnableHoldKeyRunProgramP))
                            {
                                CtlShowControl(cbShouldShowShortCutP);
                            }
                            else
                            {
                                CtlSetValue(cbShouldShowShortCutP, 0);
                                CtlHideControl(cbShouldShowShortCutP);
                            }
                            break;
                        case btnProfileManagementSetting:
                            profileManagement(settingP, false);
                            isEventHandled = true;
                            break;
                        case btnProfileManagementKey:
                            settingP->ProfileActiveKey = customKey();
                            isEventHandled = true;
                            break;
                        case btnProfileManagementKeyClear:
                            settingP->ProfileActiveKey = chrNull;
                            isEventHandled = true;
                            break;
                    }
                    break;
            }

            if (! isEventHandled)
            {
                FrmDispatchEvent(&event);
            }
        }
    }while(event.eType != appStopEvent && (! shouldExit));

    //¼
    settingP->useAsDefaultLauncher = CtlGetValue(cbSetAsDefaultLauncherP);
    settingP->ReturnToLauncherAfterCall = (CtlGetValue(cbReturnAfterInCallP) << 1) + CtlGetValue(cbReturnAfterOutCallP);
    settingP->shouldSearchProgramWhenKeyPressed = CtlGetValue(cbSearchProgramWhenKeyPressP);
    settingP->shouldEnableHoldKeyRunProgram = CtlGetValue(cbEnableHoldKeyRunProgramP);
    settingP->shouldShowShortCut = CtlGetValue(cbShouldShowShortCutP);
    settingP->shouldEnableProfileManagement = CtlGetValue(cbEnableProfileManagementP);

    if (settingP->useAsDefaultLauncher)
    {
        PrefSetPreference(prefLauncherAppCreator, APPLICATION_CREATOR);
        PrefSetPreference(prefDefaultAppCreator, APPLICATION_CREATOR);

        //notifyRegister(settingP);
    }
    else
    {
        PrefSetPreference(prefLauncherAppCreator, sysFileCLauncher);
        PrefSetPreference(prefDefaultAppCreator, 0);

        //notifyUnregister(settingP);
    }

    PrefSetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, PREFERENCE_VERSION, settingP, sizeof(SettingType), true);
    FrmReturnToForm(0);
    return returnCode;
}

#if 0
#pragma mark -----------------------------------------------------
#endif

//б
static void savePluginList(PluginListType *pluginListP, UInt16 pluginListCount)
{
    UInt16          i, j, recordNums;
    MemHandle       recordH;
    DmOpenRef       dbRef       = DmOpenDatabaseByTypeCreator(PLUGIN_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);

    if (! DmGetLastErr())
    {
        recordNums = DmNumRecordsInCategory(dbRef, dmAllCategories);

        for (i = 0; i < pluginListCount; i ++)
        {
            if (i < recordNums)     //Ҫ½¼
            {
                recordH = DmGetRecord(dbRef, i);
            }
            else    //½¼
            {
                j = dmMaxRecordIndex;
                recordH = DmNewRecord(dbRef, &j, sizeof(PluginListType));
            }

            //д
            DmWrite(MemHandleLock(recordH), 0, &pluginListP[i], sizeof(PluginListType));

            //ͷ
            MemHandleUnlock(recordH);
            DmReleaseRecord(dbRef, i, true);
        }

        //ļ¼
        if (i < recordNums)
        {
            for ( ; i < recordNums; )
            {
                DmRemoveRecord(dbRef, i);
                recordNums --;
            }
        }
        DmCloseDatabase(dbRef);
    }
}

//ȡľ
static void getPluginRectangle(PluginListType *pluginInfoP)
{
    if (pluginInfoP->creatorId == APPLICATION_CREATOR)
    {
        DmOpenRef       dbRef   = DmOpenDatabaseByTypeCreator(pluginInfoP->type, pluginInfoP->creatorId, dmModeReadOnly);
        MemHandle       rscH    = DmGetResource(PLUGIN_RECTANGLE_RESOURCE_TYPE, PLUGIN_RECTANGLE_RESOURCE_ID);

        if (rscH != NULL)
        {
            pluginInfoP->pluginRectangle = (*((RectangleType *)MemHandleLock(rscH)));
            MemHandleUnlock(rscH);
        }
        DmCloseDatabase(dbRef);
    }
    else if (pluginInfoP->type == ZL_PLUGIN_LIST_DB_TYPE)
    {
        pluginInfoP->pluginRectangle.topLeft.x = 0;
        pluginInfoP->pluginRectangle.topLeft.y = 30;
        pluginInfoP->pluginRectangle.extent.x = 160;
        pluginInfoP->pluginRectangle.extent.y = 100;
    }
}

//ȡļ
static void getPluginActiveKey(PluginListType *pluginInfoP)
{
    DmOpenRef       dbRef   = DmOpenDatabaseByTypeCreator(pluginInfoP->type, pluginInfoP->creatorId, dmModeReadOnly);
    MemHandle       rscH    = DmGetResource(PLUGIN_ACTIVE_KEY_RESOURCE_TYPE, PLUGIN_ACTIVE_KEY_RESOURCE_ID);

    if (rscH != NULL)
    {
        pluginInfoP->activeKey = (*((WChar *)MemHandleLock(rscH)));
        MemHandleUnlock(rscH);
    }
    else
    {
        pluginInfoP->activeKey = chrNull;
    }
    DmCloseDatabase(dbRef);
}

//Ƿڲб
static Boolean isPluginInPluginList(DmOpenRef dbRef, UInt32 type, UInt32 creator)
{
    UInt16              i;
    MemHandle           recordH;
    PluginListType      *recordP;
    UInt16              recordNum   = DmNumRecordsInCategory(dbRef, dmAllCategories);

    for (i = 0; i < recordNum; i ++)
    {
        recordH = DmQueryRecord(dbRef, i);
        recordP = (PluginListType *)MemHandleLock(recordH);
        if (recordP->type == type && recordP->creatorId == creator)
        {
            MemHandleUnlock(recordH);
            return true;
        }
        MemHandleUnlock(recordH);
    }

    return false;
}

//ˢ²б
static void refreshPluginList()
{
    UInt16              i, recordNums, recordId;
    MemHandle           recordH;
    PluginListType      *recordP;
    PluginListType      pluginInfo;
    ProgramListType     dbInfo;
    MemHandle           dbListH;
    SysDBListItemType   *dbListP;
    UInt16              dbListCount;
    DmSearchStateType   dmSearchState;
    DmOpenRef           dbRef   = DmOpenDatabaseByTypeCreator(PLUGIN_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);

    if (DmGetLastErr() != errNone)
    {
        DmCreateDatabase(0, "Plugin List", APPLICATION_CREATOR, PLUGIN_LIST_DB_TYPE, false);
        dbRef = DmOpenDatabaseByTypeCreator(PLUGIN_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);
    }

    recordNums = DmNumRecordsInCategory(dbRef, dmAllCategories);

    //беļ¼Ƿ
    for (i = 0; i < recordNums; i ++)
    {
        recordH = DmQueryRecord(dbRef, i);
        recordP = (PluginListType *)MemHandleLock(recordH);
        if (DmGetNextDatabaseByTypeCreator(true, &dmSearchState, recordP->type, recordP->creatorId, true, &dbInfo.cardNo, &dbInfo.dbId) == dmErrCantFind)   //򲻴ڣɾ
        {
            MemHandleUnlock(recordH);
            DmRemoveRecord(dbRef, i);
            recordNums --;
            i --;
        }
        else
        {
            MemHandleUnlock(recordH);
        }
    }

    //ȡڴеĲб
    SysCreateDataBaseList(0, APPLICATION_CREATOR, &dbListCount, &dbListH, true);
    dbListP = (SysDBListItemType *)MemHandleLock(dbListH);

    //Ƿµĳ
    for (i = 0; i < dbListCount; i ++)
    {
        if (dbListP[i].type != 'appl' && dbListP[i].type != CATEGORY_LIST_DB_TYPE && dbListP[i].type != PROGRAM_LIST_DB_TYPE &&
            dbListP[i].type != PLUGIN_LIST_DB_TYPE && dbListP[i].type != sysFileTFileStream)
        {
            if (! isPluginInPluginList(dbRef, dbListP[i].type, dbListP[i].creator))
            {
                MemSet(&pluginInfo, sizeof(PluginListType), 0);
                pluginInfo.type = dbListP[i].type;
                pluginInfo.creatorId = dbListP[i].creator;
                getPluginRectangle(&pluginInfo);
                getPluginActiveKey(&pluginInfo);

                //
                recordId = dmMaxRecordIndex;
                recordH = DmNewRecord(dbRef, &recordId, sizeof(PluginListType));
                recordP = (PluginListType *)MemHandleLock(recordH);
                DmWrite(recordP, 0, &pluginInfo, sizeof(PluginListType));
                MemHandleUnlock(recordH);
                DmReleaseRecord(dbRef, recordId, true);
            }
        }
    }
    MemHandleUnlock(dbListH);
    MemHandleFree(dbListH);

    //ȡڴеZLб
    if (SysCreateDataBaseList(ZL_PLUGIN_LIST_DB_TYPE, 0, &dbListCount, &dbListH, true))
    {
        if (dbListH != NULL)
        {
            dbListP = (SysDBListItemType *)MemHandleLock(dbListH);

            //Ƿµĳ
            for (i = 0; i < dbListCount; i ++)
            {
                if (dbListP[i].type != 'appl' && dbListP[i].type != CATEGORY_LIST_DB_TYPE && dbListP[i].type != PROGRAM_LIST_DB_TYPE &&
                    dbListP[i].type != PLUGIN_LIST_DB_TYPE && dbListP[i].type != sysFileTFileStream)
                {
                    if (! isPluginInPluginList(dbRef, dbListP[i].type, dbListP[i].creator))
                    {
                        MemSet(&pluginInfo, sizeof(PluginListType), 0);
                        pluginInfo.type = dbListP[i].type;
                        pluginInfo.creatorId = dbListP[i].creator;
                        getPluginRectangle(&pluginInfo);
                        pluginInfo.activeKey = ZLPluginPosPanel;

                        //
                        recordId = dmMaxRecordIndex;
                        recordH = DmNewRecord(dbRef, &recordId, sizeof(PluginListType));
                        recordP = (PluginListType *)MemHandleLock(recordH);
                        DmWrite(recordP, 0, &pluginInfo, sizeof(PluginListType));
                        MemHandleUnlock(recordH);
                        DmReleaseRecord(dbRef, recordId, true);
                    }
                }
            }
            MemHandleUnlock(dbListH);
            MemHandleFree(dbListH);
        }
    }

    DmCloseDatabase(dbRef);
}

//ɾ
static void performDeletePlugin(PluginListType *pluginP, GlobeType *globeP)
{
    DmSearchStateType       dmSearchState;
    UInt16                  cardNo;
    LocalID                 dbId;

    if (DmGetNextDatabaseByTypeCreator(true, &dmSearchState, pluginP->type, pluginP->creatorId, true, &cardNo, &dbId) == errNone)
    {
        //ZLǴ򿪵ģ͹ر
        if (pluginP->pluginDataP != NULL)
        {
            if (pluginP->type == ZL_PLUGIN_LIST_DB_TYPE)
            {
                ZLPluginData *dataP = pluginP->pluginDataP;

                if (dataP->isPluginOpened)
                {
                    UInt32  result;

                    SysAppLaunch(pluginP->cardNo, pluginP->dbId, 0, sysAppLaunchCmdZLPluginLoad, dataP->ZLPluginFuncPtrs, &result);
                    if (result == errNone)
                    {
                        dataP->cmdBlockTypeEx.cmdBlockType.pZLFuncPtrs = globeP->ZLFuncPtr;
                        dataP->ZLPluginFuncPtrs[ZLPluginFuncPtrClose]((ZLPluginLaunchCmdBlockType *)&(dataP->cmdBlockTypeEx));
                    }
                }
                if (dataP->cmdBlockTypeEx.cmdBlockType.dbP != NULL)
                {
                    DmCloseDatabase(dataP->cmdBlockTypeEx.cmdBlockType.dbP);
                }
            }
            MemPtrFree(pluginP->pluginDataP);
        }

        DmDeleteDatabase(cardNo, dbId);
    }
}

//б
static void pluginListDrawItem(Int16 itemNum, RectangleType *boundsP, Char **itemsTextPP)
{
    UInt16                  cardNo;
    LocalID                 dbId;
    DmSearchStateType       searchState;
    PluginListType          *pluginListP    = (*((PluginListType **)itemsTextPP));
    Char                    cacheP[128];

    if (DmGetNextDatabaseByTypeCreator(true, &searchState, pluginListP[itemNum].type, pluginListP[itemNum].creatorId, true, &cardNo, &dbId) == errNone)
    {
        if (DmDatabaseInfo(cardNo, dbId, cacheP, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL) == errNone)
        {
            WinDrawTruncChars(cacheP, StrLen(cacheP), boundsP->topLeft.x, boundsP->topLeft.y, boundsP->extent.x);
        }
    }
}

//ô
static UInt8 frmPluginSettingHandler(SettingType *settingP, GlobeType *globeP)
{
    FormType            *frmPluginSettingP;
    ListType            *lstPluginP;
    ControlType         *cbEnablePluginP;
    FieldType           *fldPluginXP;
    FieldType           *fldPluginYP;
    FieldType           *fldPluginWP;
    FieldType           *fldPluginHP;
    ControlType         *btnSetPluginKeyP;
    EventType           event;
    PluginListType      *pluginListP;
    UInt16              pluginListCount;
    ControlType         *ptriPluginTypeP;
    ListType            *lstPluginTypeP;
    Int16               i = 0;
    PluginParameterType pluginParameter;
    Boolean             isEventHandled;
    Boolean             shouldExit          = false;
    Boolean             returnCode          = SETTING_EXIT;

    FrmPopupForm(frmPluginSetting);

    do
    {
        EvtGetEvent(&event, evtWaitForever);

        if (! SysHandleEvent(&event))
        {
            isEventHandled = false;

            switch (event.eType)
            {
                case frmLoadEvent:
                    if (event.data.frmLoad.formID == frmPluginSetting)
                    {
                        frmPluginSettingP = FrmInitForm(frmPluginSetting);
                        lstPluginP = (ListType *)GET_OBJECT_POINTER(frmPluginSettingP, lstPlugin);
                        cbEnablePluginP = (ControlType *)GET_OBJECT_POINTER(frmPluginSettingP, cbEnablePlugin);
                        fldPluginXP = (FieldType *)GET_OBJECT_POINTER(frmPluginSettingP, fldPluginX);
                        fldPluginYP = (FieldType *)GET_OBJECT_POINTER(frmPluginSettingP, fldPluginY);
                        fldPluginWP = (FieldType *)GET_OBJECT_POINTER(frmPluginSettingP, fldPluginW);
                        fldPluginHP = (FieldType *)GET_OBJECT_POINTER(frmPluginSettingP, fldPluginH);
                        btnSetPluginKeyP = (ControlType *)GET_OBJECT_POINTER(frmPluginSettingP, btnSetPluginKey);
                        ptriPluginTypeP = (ControlType *)GET_OBJECT_POINTER(frmPluginSettingP, ptriPluginType);
                        lstPluginTypeP = (ListType *)GET_OBJECT_POINTER(frmPluginSettingP, lstPluginType);

                        FrmSetActiveForm(frmPluginSettingP);
                        isEventHandled = true;
                    }
                    break;
                case frmOpenEvent:
                    if (event.data.frmOpen.formID == frmPluginSetting)
                    {
                        //ÿؼ
                        FrmSetControlValue(frmPluginSettingP, FrmGetObjectIndex(frmPluginSettingP, pbtnPluginSetting5), 1);

                        //б
                        refreshPluginList();
                        getPluginList(&pluginListP, &pluginListCount, false, globeP);
                        LstSetDrawFunction(lstPluginP, pluginListDrawItem);
                        LstSetListChoices(lstPluginP, (Char **)&pluginListP, pluginListCount);

                        //
                        FrmDrawForm(frmPluginSettingP);

                        if (pluginListCount > 0)
                        {
                            LstSetSelection(lstPluginP, 0);

                            if (pluginListP[0].type == ZL_PLUGIN_LIST_DB_TYPE)
                            {
                                CtlHideControl(btnSetPluginKeyP);
                                CtlShowControl(ptriPluginTypeP);

                                //ֻ
                                LstSetSelection(lstPluginTypeP, pluginListP[0].activeKey);
                                CtlSetLabel(ptriPluginTypeP, LstGetSelectionText(lstPluginTypeP, pluginListP[0].activeKey));
                            }
                            else
                            {
                                CtlHideControl(ptriPluginTypeP);
                                if (pluginListP[0].activeKey != chrNull)
                                {
                                    CtlShowControl(btnSetPluginKeyP);
                                }
                                else
                                {
                                    CtlHideControl(btnSetPluginKeyP);
                                }
                            }

                            CtlSetValue(cbEnablePluginP, pluginListP[0].isPluginEnabled);
                            StrIToA(globeP->cacheP, pluginListP[0].pluginRectangle.topLeft.x);
                            FldDelete(fldPluginXP, 0, 3);
                            FldInsert(fldPluginXP, globeP->cacheP, StrLen(globeP->cacheP));
                            StrIToA(globeP->cacheP, pluginListP[0].pluginRectangle.topLeft.y);
                            FldDelete(fldPluginYP, 0, 3);
                            FldInsert(fldPluginYP, globeP->cacheP, StrLen(globeP->cacheP));
                            StrIToA(globeP->cacheP, pluginListP[0].pluginRectangle.extent.x);
                            FldDelete(fldPluginWP, 0, 3);
                            FldInsert(fldPluginWP, globeP->cacheP, StrLen(globeP->cacheP));
                            StrIToA(globeP->cacheP, pluginListP[0].pluginRectangle.extent.y);
                            FldDelete(fldPluginHP, 0, 3);
                            FldInsert(fldPluginHP, globeP->cacheP, StrLen(globeP->cacheP));
                            globeP->cacheP[0] = '\0';
                        }
                        else
                        {
                            CtlHideControl(btnSetPluginKeyP);
                            CtlHideControl(ptriPluginTypeP);
                            LstSetSelection(lstPluginP, noListSelection);
                        }

                        //
                        HsNavObjectTakeFocus(frmPluginSettingP, pbtnPluginSetting5);
                        isEventHandled = true;
                    }
                    break;
                case lstSelectEvent:
                    if (event.data.lstSelect.listID == lstPlugin && pluginListCount > 0)
                    {
                        if (pluginListP[event.data.lstSelect.selection].type == ZL_PLUGIN_LIST_DB_TYPE)
                        {
                            Int16   numItem;

                            CtlHideControl(btnSetPluginKeyP);
                            CtlShowControl(ptriPluginTypeP);
                            //ֻ
                            numItem = pluginListP[event.data.lstSelect.selection].activeKey;
                            LstSetSelection(lstPluginTypeP, numItem);
                            CtlSetLabel(ptriPluginTypeP, LstGetSelectionText(lstPluginTypeP, numItem));
                        }
                        else
                        {
                            CtlHideControl(ptriPluginTypeP);
                            if (pluginListP[event.data.lstSelect.selection].activeKey != chrNull)
                            {
                                CtlShowControl(btnSetPluginKeyP);
                            }
                            else
                            {
                                CtlHideControl(btnSetPluginKeyP);
                            }
                        }

                        CtlSetValue(cbEnablePluginP, pluginListP[event.data.lstSelect.selection].isPluginEnabled);

                        StrIToA(globeP->cacheP, pluginListP[event.data.lstSelect.selection].pluginRectangle.topLeft.x);
                        FldDelete(fldPluginXP, 0, 3);
                        FldInsert(fldPluginXP, globeP->cacheP, StrLen(globeP->cacheP));

                        StrIToA(globeP->cacheP, pluginListP[event.data.lstSelect.selection].pluginRectangle.topLeft.y);
                        FldDelete(fldPluginYP, 0, 3);
                        FldInsert(fldPluginYP, globeP->cacheP, StrLen(globeP->cacheP));

                        StrIToA(globeP->cacheP, pluginListP[event.data.lstSelect.selection].pluginRectangle.extent.x);
                        FldDelete(fldPluginWP, 0, 3);
                        FldInsert(fldPluginWP, globeP->cacheP, StrLen(globeP->cacheP));

                        StrIToA(globeP->cacheP, pluginListP[event.data.lstSelect.selection].pluginRectangle.extent.y);
                        FldDelete(fldPluginHP, 0, 3);
                        FldInsert(fldPluginHP, globeP->cacheP, StrLen(globeP->cacheP));

                        globeP->cacheP[0] = '\0';
                    }
                    break;
                case popSelectEvent:
                    //ZL
                    if (event.data.popSelect.listID == lstPluginType && event.data.popSelect.selection != noListSelection)
                    {
                        pluginListP[i].activeKey = event.data.popSelect.selection;
                    }
                    break;
                case fldChangedEvent:
                    i = LstGetSelection(lstPluginP);
                    if (i != noListSelection)
                    {
                        switch (event.data.fldChanged.fieldID)
                        {
                            case fldPluginX:
                                pluginListP[i].pluginRectangle.topLeft.x = (Coord)StrAToI(FldGetTextPtr(fldPluginXP));
                                break;
                            case fldPluginY:
                                pluginListP[i].pluginRectangle.topLeft.y = (Coord)StrAToI(FldGetTextPtr(fldPluginYP));
                                break;
                            case fldPluginW:
                                pluginListP[i].pluginRectangle.extent.x = (Coord)StrAToI(FldGetTextPtr(fldPluginWP));
                                break;
                            case fldPluginH:
                                pluginListP[i].pluginRectangle.extent.y = (Coord)StrAToI(FldGetTextPtr(fldPluginHP));
                                break;
                        }
                    }
                    break;
                case ctlSelectEvent:
                    switch (event.data.ctlSelect.controlID)
                    {
                        case btnPluginOK:
                            shouldExit = true;
                            isEventHandled = true;
                            returnCode = SETTING_EXIT;
                            break;
                        case cbEnablePlugin:
                            i = LstGetSelection(lstPluginP);
                            if (i != noListSelection)
                            {
                                pluginListP[i].isPluginEnabled = (Boolean)CtlGetValue(cbEnablePluginP);
                            }
                            else
                            {
                                CtlSetValue(cbEnablePluginP, 0);
                            }
                            isEventHandled = true;
                            break;
                        case btnSetupPlugin:
                            i = LstGetSelection(lstPluginP);
                            if (i != noListSelection)
                            {
                                UInt32  result;

                                //NeoĲ
                                if (pluginListP[i].creatorId == APPLICATION_CREATOR)
                                {
                                    pluginParameter.actionType = ACTION_TYPE_SETUP;
                                    pluginParameter.pluginRectangle = pluginListP[i].pluginRectangle;
                                    pluginParameter.pluginDataP = NULL;
                                    SysAppLaunch(pluginListP[i].cardNo, pluginListP[i].dbId, 0, LAUNCH_CODE_PLUGIN_ACTION, &pluginParameter, &result);
                                }
                                else if (pluginListP[i].type == ZL_PLUGIN_LIST_DB_TYPE) //ZL
                                {
                                    ZLPluginData    *dataP = (ZLPluginData *)(pluginListP[i].pluginDataP);

                                    if (dataP != NULL && dataP->isPluginOpened && dataP->cmdBlockTypeEx.cmdBlockType.dbP != NULL)
                                    {
                                        SysAppLaunch(globeP->pluginListP[i].cardNo, globeP->pluginListP[i].dbId, 0, sysAppLaunchCmdZLPluginLoad, dataP->ZLPluginFuncPtrs, &result);
                                        if (result == errNone)
                                        {
                                            dataP->cmdBlockTypeEx.cmdBlockType.pZLFuncPtrs = globeP->ZLFuncPtr;
                                            dataP->cmdBlockTypeEx.pluginDataP = (void *)dataP;
                                            dataP->ZLPluginFuncPtrs[ZLPluginFuncPtrPreferences]((ZLPluginLaunchCmdBlockType *)&(dataP->cmdBlockTypeEx));
                                        }
                                    }
                                    else
                                    {
                                        ZLPluginFuncPtr aZLPluginFuncPtrs[ZLPluginNumFuncPtrs];

                                        SysAppLaunch(pluginListP[i].cardNo, pluginListP[i].dbId, 0, sysAppLaunchCmdZLPluginLoad, aZLPluginFuncPtrs, &result);
                                        if (result == errNone)
                                        {
                                            ZLPluginLaunchCmdBlockTypeEx blockTypeEx;

                                            blockTypeEx.creatorId = pluginListP[i].creatorId;
                                            blockTypeEx.pluginDataP = NULL;
                                            blockTypeEx.cmdBlockType.pZLFuncPtrs = globeP->ZLFuncPtr;
                                            blockTypeEx.cmdBlockType.dbP = DmOpenDatabase(pluginListP[i].cardNo, pluginListP[i].dbId, dmModeReadOnly);
                                            if (blockTypeEx.cmdBlockType.dbP != NULL)
                                            {
                                                result = aZLPluginFuncPtrs[ZLPluginFuncPtrOpen]((ZLPluginLaunchCmdBlockType *)&blockTypeEx);
                                                if (result == errNone)
                                                {
                                                    aZLPluginFuncPtrs[ZLPluginFuncPtrPreferences]((ZLPluginLaunchCmdBlockType *)&blockTypeEx);
                                                    aZLPluginFuncPtrs[ZLPluginFuncPtrClose]((ZLPluginLaunchCmdBlockType *)&blockTypeEx);
                                                }

                                                DmCloseDatabase(blockTypeEx.cmdBlockType.dbP);
                                            }
                                        }
                                    }
                                }
                            }
                            isEventHandled = true;
                            break;
                        case btnSetPluginKey:
                            i = LstGetSelection(lstPluginP);
                            if (i != noListSelection)
                            {
                                pluginListP[i].activeKey = customKey();
                            }
                            else
                            {
                                CtlSetValue(cbEnablePluginP, 0);
                            }
                            isEventHandled = true;
                            break;
                        case btnDeletePlugin:
                            i = LstGetSelection(lstPluginP);
                            if (i != noListSelection)
                            {
                                if (FrmCustomAlert(alertConfirmation, STRING_CONFIRM_DELETE_PLUGIN, "", "") == 0)
                                {
                                    performDeletePlugin(&pluginListP[i], globeP);
                                    freePluginList(pluginListP, pluginListCount);
                                    refreshPluginList();
                                    getPluginList(&pluginListP, &pluginListCount, false, globeP);
                                    LstSetDrawFunction(lstPluginP, pluginListDrawItem);
                                    LstSetListChoices(lstPluginP, (Char **)&pluginListP, pluginListCount);
                                    LstSetSelection(lstPluginP, noListSelection);
                                    LstDrawList(lstPluginP);
                                    CtlSetValue(cbEnablePluginP, 0);
                                    FldDelete(fldPluginXP, 0, 3);
                                    FldDelete(fldPluginYP, 0, 3);
                                    FldDelete(fldPluginWP, 0, 3);
                                    FldDelete(fldPluginHP, 0, 3);
                                }
                            }
                            isEventHandled = true;
                            break;
                        case pbtnGeneralSetting5:
                            shouldExit = true;
                            returnCode = SETTING_GENERAL;
                            isEventHandled = true;
                            break;
                        case pbtnUISetting5:
                            shouldExit = true;
                            returnCode = SETTING_UI;
                            isEventHandled = true;
                            break;
                        case pbtnColorSetting5:
                            shouldExit = true;
                            returnCode = SETTING_COLOR;
                            isEventHandled = true;
                            break;
                        case pbtnAdvanceSetting5:
                            shouldExit = true;
                            returnCode = SETTING_ADVANCE;
                            isEventHandled = true;
                            break;
                    }
                    break;
                case keyDownEvent:
                    if (! EvtKeydownIsVirtual(&event))
                    {
                        if (FrmGetFocus(frmPluginSettingP) == FrmGetObjectIndex(frmPluginSettingP, fldPluginX))
                        {
                            isEventHandled = FldHandleEvent(fldPluginXP, &event);
                            if (isEventHandled)
                            {
                                FldSendChangeNotification(fldPluginXP);
                            }
                        }
                        else if (FrmGetFocus(frmPluginSettingP) == FrmGetObjectIndex(frmPluginSettingP, fldPluginY))
                        {
                            isEventHandled = FldHandleEvent(fldPluginYP, &event);
                            if (isEventHandled)
                            {
                                FldSendChangeNotification(fldPluginYP);
                            }
                        }
                        else if (FrmGetFocus(frmPluginSettingP) == FrmGetObjectIndex(frmPluginSettingP, fldPluginW))
                        {
                            isEventHandled = FldHandleEvent(fldPluginWP, &event);
                            if (isEventHandled)
                            {
                                FldSendChangeNotification(fldPluginWP);
                            }
                        }
                        else if (FrmGetFocus(frmPluginSettingP) == FrmGetObjectIndex(frmPluginSettingP, fldPluginH))
                        {
                            isEventHandled = FldHandleEvent(fldPluginHP, &event);
                            if (isEventHandled)
                            {
                                FldSendChangeNotification(fldPluginHP);
                            }
                        }
                    }
                    break;
            }

            if (! isEventHandled)
            {
                FrmDispatchEvent(&event);
            }
        }
    }while(event.eType != appStopEvent && (! shouldExit));

    savePluginList(pluginListP, pluginListCount);

    freePluginList(pluginListP, pluginListCount);

    FrmReturnToForm(0);
    return returnCode;
}

#if 0
#pragma mark -----------------------------------------------------
#endif

//߼ô
static UInt8 frmAdvanceSettingHandler(SettingType *settingP, GlobeType *globeP)
{
    FormType        *frmAdvanceSettingP;
    ControlType     *cbShouldSearchInGlobeP;
    ControlType     *cbShouldShowSearchP;
    ControlType     *cbActivePluginInPhoneViewOnlyP;
    ControlType     *cbSkipAllCategoryP;
    ControlType     *cbSkipEmptyCategoryP;
    ControlType     *cbLaunchTheOnlyMatchedProgramP;
    ControlType     *cbAutoRaiseProgramP;
    ControlType     *cbAutoUpdateProgramListP;
    EventType       event;
    Boolean         isEventHandled;
    Boolean         shouldExit          = false;
    Boolean         returnCode          = SETTING_EXIT;

    FrmPopupForm(frmAdvanceSetting);

    do
    {
        EvtGetEvent(&event, evtWaitForever);

        if (! SysHandleEvent(&event))
        {
            isEventHandled = false;

            switch (event.eType)
            {
                case frmLoadEvent:
                    if (event.data.frmLoad.formID == frmAdvanceSetting)
                    {
                        frmAdvanceSettingP = FrmInitForm(frmAdvanceSetting);
                        cbShouldSearchInGlobeP = (ControlType *)GET_OBJECT_POINTER(frmAdvanceSettingP, cbShouldSearchInGlobe);
                        cbShouldShowSearchP = (ControlType *)GET_OBJECT_POINTER(frmAdvanceSettingP, cbShouldShowSearch);
                        cbSkipAllCategoryP = (ControlType *)GET_OBJECT_POINTER(frmAdvanceSettingP, cbSkipAllCategory);
                        cbSkipEmptyCategoryP = (ControlType *)GET_OBJECT_POINTER(frmAdvanceSettingP, cbSkipEmptyCategory);
                        cbLaunchTheOnlyMatchedProgramP = (ControlType *)GET_OBJECT_POINTER(frmAdvanceSettingP, cbLaunchTheOnlyMatchedProgram);
                        cbAutoRaiseProgramP = (ControlType *)GET_OBJECT_POINTER(frmAdvanceSettingP, cbAutoRaiseProgram);
                        cbAutoUpdateProgramListP = (ControlType *)GET_OBJECT_POINTER(frmAdvanceSettingP, cbAutoUpdateProgramList);
                        cbActivePluginInPhoneViewOnlyP = (ControlType *)GET_OBJECT_POINTER(frmAdvanceSettingP, cbActivePluginInPhoneViewOnly);
                        FrmSetActiveForm(frmAdvanceSettingP);
                        isEventHandled = true;
                    }
                    break;
                case frmOpenEvent:
                    if (event.data.frmOpen.formID == frmAdvanceSetting)
                    {
                        //ÿؼ
                        FrmSetControlValue(frmAdvanceSettingP, FrmGetObjectIndex(frmAdvanceSettingP, pbtnAdvanceSetting4), 1);
                        CtlSetValue(cbShouldSearchInGlobeP, settingP->shouldSearchInGlobe);
                        CtlSetValue(cbShouldShowSearchP, settingP->shouldShowSearch);
                        CtlSetValue(cbSkipAllCategoryP, settingP->shouldSkipAllCategory);
                        CtlSetValue(cbSkipEmptyCategoryP, settingP->shouldSkipEmptyCategory);
                        CtlSetValue(cbLaunchTheOnlyMatchedProgramP, settingP->shouldLaunchTheOnlyMatchedProgram);
                        CtlSetValue(cbActivePluginInPhoneViewOnlyP, settingP->shouldActivePluginInPhoneViewOnly);
                        CtlSetValue(cbAutoRaiseProgramP, settingP->shouldAutoRaiseProgram);
                        CtlSetValue(cbAutoUpdateProgramListP, settingP->shouldAutoUpdateProgramList);

                        //
                        FrmDrawForm(frmAdvanceSettingP);

                        //
                        HsNavObjectTakeFocus(frmAdvanceSettingP, pbtnAdvanceSetting4);
                        isEventHandled = true;
                    }
                    break;
                case ctlSelectEvent:
                    switch (event.data.ctlSelect.controlID)
                    {
                        case btnAdvanceOK:
                            shouldExit = true;
                            isEventHandled = true;
                            returnCode = SETTING_EXIT;
                            break;
                        case pbtnGeneralSetting4:
                            shouldExit = true;
                            returnCode = SETTING_GENERAL;
                            isEventHandled = true;
                            break;
                        case pbtnUISetting4:
                            shouldExit = true;
                            returnCode = SETTING_UI;
                            isEventHandled = true;
                            break;
                        case pbtnColorSetting4:
                            shouldExit = true;
                            returnCode = SETTING_COLOR;
                            isEventHandled = true;
                            break;
                        case pbtnPluginSetting4:
                            shouldExit = true;
                            returnCode = SETTING_PLUGIN;
                            isEventHandled = true;
                            break;
                        case cbAutoRaiseProgram:
                        case cbAutoUpdateProgramList:
                            isEventHandled = true;
                            break;
                    }
                    break;
            }

            if (! isEventHandled)
            {
                FrmDispatchEvent(&event);
            }
        }
    }while(event.eType != appStopEvent && (! shouldExit));

    //¼
    settingP->shouldSearchInGlobe = CtlGetValue(cbShouldSearchInGlobeP);
    settingP->shouldShowSearch = CtlGetValue(cbShouldShowSearchP);
    settingP->shouldActivePluginInPhoneViewOnly = CtlGetValue(cbActivePluginInPhoneViewOnlyP);
    settingP->shouldAutoRaiseProgram = CtlGetValue(cbAutoRaiseProgramP);
    settingP->shouldAutoUpdateProgramList = CtlGetValue(cbAutoUpdateProgramListP);
    settingP->shouldSkipAllCategory = CtlGetValue(cbSkipAllCategoryP);
    settingP->shouldSkipEmptyCategory = CtlGetValue(cbSkipEmptyCategoryP);
    settingP->shouldLaunchTheOnlyMatchedProgram = CtlGetValue(cbLaunchTheOnlyMatchedProgramP);

    FrmReturnToForm(0);
    PrefSetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, PREFERENCE_VERSION, settingP, sizeof(SettingType), true);
    return returnCode;
}

#if 0
#pragma mark -----------------------------------------------------
#endif

static void frmCustomColorDrawColorSqure(SettingType *settingP)
{
    RectangleType       rectangle;
    RGBColorType        defaultColor;
    RGBColorType        defaultBGColor;
    UInt16              i;

    rectangle.topLeft.x = 65;
    rectangle.topLeft.y = 35;
    rectangle.extent.x = 30;
    rectangle.extent.y = 9;

    //
    WinSetForeColorRGB(&settingP->formFillColor, &defaultColor);
    WinSetBackColorRGB(&defaultColor, &defaultBGColor);
    WinDrawRectangle(&rectangle, 0);
    WinEraseRectangleFrame(rectangleFrame, &rectangle);

    //ײ״̬
    rectangle.topLeft.y += 12;
    WinSetForeColorRGB(&settingP->topStatusFillColor, NULL);
    WinDrawRectangle(&rectangle, 0);
    WinEraseRectangleFrame(rectangleFrame, &rectangle);

    //ʱ
    rectangle.topLeft.y += 12;
    WinSetForeColorRGB(&settingP->formFrameColor, NULL);
    WinDrawRectangle(&rectangle, 0);
    WinEraseRectangleFrame(rectangleFrame, &rectangle);

    //ײ״̬
    rectangle.topLeft.y += 12;
    WinSetForeColorRGB(&settingP->statusDigitalColor, NULL);
    WinDrawRectangle(&rectangle, 0);
    WinEraseRectangleFrame(rectangleFrame, &rectangle);

    //ı
    rectangle.topLeft.y += 12;
    WinSetForeColorRGB(&settingP->textColor, NULL);
    WinDrawRectangle(&rectangle, 0);
    WinEraseRectangleFrame(rectangleFrame, &rectangle);

    //
    rectangle.topLeft.y += 12;
    WinSetForeColorRGB(&settingP->textOutlineColor, NULL);
    WinDrawRectangle(&rectangle, 0);
    WinEraseRectangleFrame(rectangleFrame, &rectangle);

    //ɫ
    if (settingP->deviceModel != TREO_600)
    {
        rectangle.topLeft.x = 43; rectangle.topLeft.y = 107; rectangle.extent.x = 13; rectangle.extent.y = 9;
        for (i = 0; i < 6; i ++)
        {
            WinSetForeColorRGB(&settingP->focusRingColor[i], NULL);
            WinDrawRectangle(&rectangle, 0);
            WinEraseRectangleFrame(rectangleFrame, &rectangle);
            rectangle.topLeft.x += 19;
        }
    }

    //ָǰɫ
    WinSetForeColorRGB(&defaultColor, NULL);
    WinSetBackColorRGB(&defaultBGColor, NULL);
}

//ɫô
static UInt8 frmColorSettingHandler(SettingType *settingP, GlobeType *globeP)
{
    EventType           event;
    FormType            *frmColorSettingP;
    UInt16              i;
    IndexedColorType    indexColor;
    Boolean             isEventHandled;
    Boolean             shouldExit          = false;
    UInt8               returnCode          = SETTING_EXIT;

    FrmPopupForm(frmColorSetting);

    do
    {
        EvtGetEvent(&event, evtWaitForever);

        if (! SysHandleEvent(&event))
        {
            isEventHandled = false;

            switch (event.eType)
            {
                case frmLoadEvent:
                    if (event.data.frmLoad.formID == frmColorSetting)
                    {
                        frmColorSettingP = FrmInitForm(frmColorSetting);
                        FrmSetActiveForm(frmColorSettingP);
                        isEventHandled = true;
                    }
                    break;
                case frmOpenEvent:
                    if (event.data.frmOpen.formID == frmColorSetting)
                    {
                        FrmSetControlValue(frmColorSettingP, FrmGetObjectIndex(frmColorSettingP, pbtnColorSetting3), 1);
                        FrmDrawForm(frmColorSettingP);
                        frmCustomColorDrawColorSqure(settingP);

                        if (settingP->deviceModel == TREO_600)
                        {
                            for (i = lbFocusRingColor; i <= btnCustomFocusRingColor6; i ++)
                            {
                                FrmHideObject(frmColorSettingP, FrmGetObjectIndex(frmColorSettingP, i));
                            }
                        }

                        //
                        HsNavObjectTakeFocus(frmColorSettingP, pbtnColorSetting3);
                        isEventHandled = true;
                    }
                    break;
                case ctlSelectEvent:
                    switch (event.data.ctlSelect.controlID)
                    {
                        case btnColorOK:
                            shouldExit = true;
                            returnCode = SETTING_EXIT;
                            break;
                        case pbtnGeneralSetting3:
                            shouldExit = true;
                            returnCode = SETTING_GENERAL;
                            isEventHandled = true;
                            break;
                        case pbtnUISetting3:
                            shouldExit = true;
                            returnCode = SETTING_UI;
                            isEventHandled = true;
                            break;
                        case pbtnAdvanceSetting3:
                            shouldExit = true;
                            returnCode = SETTING_ADVANCE;
                            isEventHandled = true;
                            break;
                        case pbtnPluginSetting3:
                            shouldExit = true;
                            returnCode = SETTING_PLUGIN;
                            isEventHandled = true;
                            break;
                        case btnDefaultColor:
                            getDefaultColor(settingP);
                            break;
                        case btnCustomFormFill:
                            indexColor = WinRGBToIndex(&settingP->formFillColor);
                            UIPickColor(&indexColor, &settingP->formFillColor, UIPickColorStartPalette, "", NULL);
                            break;
                        case btnCustomFormFrame:
                            indexColor = WinRGBToIndex(&settingP->formFrameColor);
                            UIPickColor(&indexColor, &settingP->formFrameColor, UIPickColorStartPalette, "ʱ", NULL);
                            break;
                        case btnCustomTopStatusFill:
                            indexColor = WinRGBToIndex(&settingP->topStatusFillColor);
                            UIPickColor(&indexColor, &settingP->topStatusFillColor, UIPickColorStartPalette, "״̬", NULL);
                            break;
                        case btnCustomStatusDigital:
                            indexColor = WinRGBToIndex(&settingP->statusDigitalColor);
                            UIPickColor(&indexColor, &settingP->statusDigitalColor, UIPickColorStartPalette, "״̬", NULL);
                            break;
                        case btnCustomText:
                            indexColor = WinRGBToIndex(&settingP->textColor);
                            UIPickColor(&indexColor, &settingP->textColor, UIPickColorStartPalette, "ı", NULL);
                            break;
                        case btnCustomTextOutline:
                            indexColor = WinRGBToIndex(&settingP->textOutlineColor);
                            UIPickColor(&indexColor, &settingP->textOutlineColor, UIPickColorStartPalette, "ı", NULL);
                            break;
                        case btnCustomFocusRingColor1:
                            indexColor = WinRGBToIndex(&settingP->focusRingColor[0]);
                            UIPickColor(&indexColor, &settingP->focusRingColor[0], UIPickColorStartPalette, "", NULL);
                            if (FrmCustomAlert(alertConfirmation, STRING_FOCUS_RING_COLOR_CONFIRM, "", "") == 0)    //Զɫ
                            {
                                if (settingP->focusRingColor[0].r == 0 && settingP->focusRingColor[0].g == 51 && settingP->focusRingColor[0].b == 204)
                                {
                                    settingP->focusRingColor[1].r = 0; settingP->focusRingColor[1].g = 102; settingP->focusRingColor[1].b = 255;
                                    settingP->focusRingColor[2].r = 51; settingP->focusRingColor[2].g = 153; settingP->focusRingColor[2].b = 255;
                                    settingP->focusRingColor[3].r = 102; settingP->focusRingColor[3].g = 204; settingP->focusRingColor[3].b = 255;
                                    settingP->focusRingColor[4].r = 153; settingP->focusRingColor[4].g = 255; settingP->focusRingColor[4].b = 255;
                                    settingP->focusRingColor[5].r = 204; settingP->focusRingColor[5].g = 255; settingP->focusRingColor[5].b = 255;
                                }
                                else
                                {
                                    Int32   r, g, b;

                                    //תyuv
                                    Int32   y   = (((Int32)settingP->focusRingColor[0].r) * 299 + ((Int32)settingP->focusRingColor[0].g) * 587 + ((Int32)settingP->focusRingColor[0].b) * 114) / 1000;
                                    Int32   u   = (((Int32)settingP->focusRingColor[0].b) * 436 - ((Int32)settingP->focusRingColor[0].r) * 147 - ((Int32)settingP->focusRingColor[0].g) * 289) / 1000;
                                    Int32   v   = (((Int32)settingP->focusRingColor[0].r) * 615 - ((Int32)settingP->focusRingColor[0].g) * 515 - ((Int32)settingP->focusRingColor[0].b) * 100) / 1000;

                                    //yֵΪ37תrgb
                                    for (i = 1; i < 6; i ++)
                                    {
                                        switch (i)
                                        {
                                            case 1:
                                                y += 36;
                                                break;
                                            case 2:
                                                y += 45;
                                                break;
                                            case 3:
                                                y += 45;
                                                break;
                                            case 4:
                                                y += 46;
                                                break;
                                            case 5:
                                                y += 14;
                                                break;
                                        }

                                        if (y > 255)
                                        {
                                            y = 255;
                                        }

                                        r = y + v * 114 / 100;
                                        if (r < 0)
                                        {
                                            r = 0;
                                        }
                                        else if (r > 255)
                                        {
                                            r = 255;
                                        }

                                        g = y - (u * 39 + v * 58) / 100;
                                        if (g < 0)
                                        {
                                            g = 0;
                                        }
                                        else if (g > 255)
                                        {
                                            g = 255;
                                        }

                                        b = y + u * 203 / 100;
                                        if (b < 0)
                                        {
                                            b = 0;
                                        }
                                        else if (b > 255)
                                        {
                                            b = 255;
                                        }

                                        settingP->focusRingColor[i].r = r;
                                        settingP->focusRingColor[i].g = g;
                                        settingP->focusRingColor[i].b = b;
                                    }
                                }
                            }
                            break;
                        case btnCustomFocusRingColor2:
                        case btnCustomFocusRingColor3:
                        case btnCustomFocusRingColor4:
                        case btnCustomFocusRingColor5:
                        case btnCustomFocusRingColor6:
                            indexColor = WinRGBToIndex(&settingP->focusRingColor[event.data.ctlSelect.controlID - btnCustomFocusRingColor1]);
                            UIPickColor(&indexColor, &settingP->focusRingColor[event.data.ctlSelect.controlID - btnCustomFocusRingColor1], UIPickColorStartPalette, "", NULL);
                            break;
                    }
                    FrmDrawForm(frmColorSettingP);
                    frmCustomColorDrawColorSqure(settingP);
                    isEventHandled = true;
                    break;
            }

            if (! isEventHandled)
            {
                FrmDispatchEvent(&event);
            }
        }
    }while(event.eType != appStopEvent && shouldExit == false);

    getInvertColor(&settingP->textOnMaskColor, &settingP->formFrameColor);

    if (settingP->deviceModel != TREO_600)
    {
        for (i = hsNavFocusColorRing1; i <= hsNavFocusColorRing6; i ++)
        {
            HsNavSetFocusColor(i, &settingP->focusRingColor[i - hsNavFocusColorRing1], NULL);
        }
    }

    PrefSetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, PREFERENCE_VERSION, settingP, sizeof(SettingType), true);
    FrmReturnToForm(0);
    return returnCode;
}

#if 0
#pragma mark -----------------------------------------------------
#endif

static Boolean frmSetBackgroundEventHandler(SettingType *settingP, GlobeType *globeP)
{
    UInt16      photoLibRef;
    Boolean     returnValue = true;
    Boolean     libError    = false;

    if (SysLibLoad(PalmPhotoLibTypeID, PalmPhotoLibCreatorID, &photoLibRef) == errNone)
    {
        if (PalmPhotoLibOpen(photoLibRef) == errNone)
        {
            PalmPhotoSelectionParam     photoSelection;

            MemSet(&photoSelection, sizeof(PalmPhotoSelectionParam), 0);
            photoSelection.albumID = PALM_PHOTO_ALBUM_ALL;
            photoSelection.offset = 0;
            photoSelection.selectionCount = 1;
            if (PalmPhotoSelectDlg(photoLibRef, &photoSelection, palmPhotoDlgSingleSelection, true) == errNone)
            {
                PalmPhotoImageInfo      imageInfo;
                if (PalmPhotoGetImageInfo(photoLibRef, photoSelection.selectedImages.imageH[0], &imageInfo) == errNone)
                {
                    UInt16          error;
                    UInt32          width;
                    UInt32          height;
                    BitmapType      *bmpP;

                    if (imageInfo.height > imageInfo.width)
                    {
                        width = 320;
                        height = imageInfo.height * 320 / imageInfo.width;
                    }
                    else
                    {
                        height = 320;
                        width = imageInfo.width * 320 / imageInfo.height;
                    }
                    bmpP = BmpCreate(width, height, 16, NULL, &error);

                    if (error == errNone)
                    {
                        WinHandle       offscreenWindowH    = WinCreateBitmapWindow(bmpP, &error);

                        if (error == errNone)
                        {
                            PalmPhotoDisplayParam   displayParam;

                            MemSet(&displayParam, sizeof(PalmPhotoDisplayParam), 0);
                            displayParam.winH = offscreenWindowH;
                            displayParam.rect.topLeft.x = 0; displayParam.rect.topLeft.y = 0;
                            displayParam.rect.extent.x = width; displayParam.rect.extent.y = height;
                            if (PalmPhotoDisplayImageToSizeV3(photoLibRef, photoSelection.selectedImages.imageH[0], &displayParam) == errNone)
                            {
                                UInt32      bmpBitsSize;
                                void        *bmpBitsP       = BmpGetBits(bmpP);
                                FileHand    fileH           = FileOpen(0, WALLPAPER_CACHE_NAME, sysFileTFileStream, APPLICATION_CREATOR, fileModeReadWrite, &error);

                                if (error == errNone)
                                {
                                    //
                                    FileWrite(fileH, &width, 4, 1, &error);
                                    FileWrite(fileH, &height, 4, 1, &error);
                                    //ͼƬ
                                    BmpGetSizes(bmpP, &bmpBitsSize, NULL);
                                    FileWrite(fileH, bmpBitsP, bmpBitsSize, 1, &error);

                                    FileClose(fileH);
                                }
                            }
                            else
                            {
                                returnValue = false;
                            }
                            WinDeleteWindow(offscreenWindowH, false);
                        }
                        else
                        {
                            returnValue = false;
                        }
                        BmpDelete(bmpP);
                    }
                    else
                    {
                        returnValue = false;
                    }
                }
                else
                {
                    returnValue = false;
                }
                PalmPhotoFreeSelections(photoLibRef, &photoSelection);
            }
            else
            {
                if (globeP->bmpBackgdP == NULL)
                    returnValue = false;
            }

            PalmPhotoLibClose(photoLibRef);
        }
        else
        {
            libError = true;
            returnValue = false;
        }

        SysLibRemove(photoLibRef);
    }
    else
    {
        libError = true;
        returnValue = false;
    }

    if (libError)
    {
        FrmCustomAlert(alertError, STRING_PHOTO_LIB_ERROR, "", "");
    }

    return returnValue;
}

static Int16 getListSelectionFromPatternType(PatternType currentType)
{
    switch (currentType)
    {
        case whitePattern:
            return 0;
            break;
        case lightGrayPattern:
            return 1;
            break;
        case grayPattern:
            return 2;
            break;
        case darkGrayPattern:
            return 3;
            break;
        case blackPattern:
            return 4;
            break;
    }

    return noListSelection;
}

static PatternType getPatternTypeFromListSelection(Int16 selection)
{
    switch (selection)
    {
        case 0:
            return whitePattern;
            break;
        case 1:
            return lightGrayPattern;
            break;
        case 2:
            return grayPattern;
            break;
        case 3:
            return darkGrayPattern;
            break;
        case 4:
            return blackPattern;
            break;
    }

    return grayPattern;
}

static void frmCustomCarrierEventHandler(SettingType *settingP)
{
    EventType       event;
    FormType        *frmCustomCarrierP;
    FieldType       *fldCustomCarrierP;
    Boolean         isEventHandled;
    Boolean         shouldExit          = false;

    FrmPopupForm(frmCustomCarrier);

    do
    {
        EvtGetEvent(&event, evtWaitForever);

        if (! SysHandleEvent(&event))
        {
            isEventHandled = false;

            switch (event.eType)
            {
                case frmLoadEvent:
                    if (event.data.frmLoad.formID == frmCustomCarrier)
                    {
                        frmCustomCarrierP = FrmInitForm(frmCustomCarrier);
                        FrmSetActiveForm(frmCustomCarrierP);
                        fldCustomCarrierP = (FieldType *)GET_OBJECT_POINTER(frmCustomCarrierP, fldCustomCarrier);
                        isEventHandled = true;
                    }
                    break;
                case frmOpenEvent:
                    if (event.data.frmOpen.formID == frmCustomCarrier)
                    {
                        FrmDrawForm(frmCustomCarrierP);
                        FldInsert(fldCustomCarrierP, settingP->customCarrierP, StrLen(settingP->customCarrierP));
                        isEventHandled = true;
                    }
                    break;
                case ctlSelectEvent:
                    switch (event.data.ctlSelect.controlID)
                    {
                        case btnCarrierOK:
                            shouldExit = true;
                            MemSet(settingP->customCarrierP, 21, 0);
                            if (FldGetTextLength(fldCustomCarrierP) > 0)
                            {
                                StrCopy(settingP->customCarrierP, FldGetTextPtr(fldCustomCarrierP));
                            }
                            else
                            {
                                StrCopy(settingP->customCarrierP, " ");
                            }
                            break;
                    }
                    isEventHandled = true;
                    break;
            }

            if (! isEventHandled)
            {
                FrmDispatchEvent(&event);
            }
        }
    }while(event.eType != appStopEvent && shouldExit == false);

    PrefSetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, PREFERENCE_VERSION, settingP, sizeof(SettingType), true);
    FrmReturnToForm(0);
}

//ô
static UInt8 frmUISettingHandler(SettingType *settingP, GlobeType *globeP)
{
    FormType        *frmUISettingP;
    ControlType     *cbCustomCarrierP;
    ControlType     *cbShowDateTimeP;
    ControlType     *cbAddMaskP;
    ControlType     *cbAddLineP;
    ControlType     *cbDrawOutlineP;
    ControlType     *cbShowTopIconsP;
    ControlType     *cbShowTopProgramsP;
    //ControlType       *lbPatternTypeP;
    ControlType     *ptriPatternTypeP;
    ListType        *lstPatternTypeP;
    ControlType     *ptriFocusRingStyleP;
    ListType        *lstFocusRingStyleP;
    ControlType     *cbShowBackgdP;
    EventType       event;
    Boolean         isEventHandled;
    Boolean         shouldExit          = false;
    UInt8           returnCode          = SETTING_EXIT;

    FrmPopupForm(frmUISetting);

    do
    {
        EvtGetEvent(&event, evtWaitForever);

        if (! SysHandleEvent(&event))
        {
            isEventHandled = false;

            switch (event.eType)
            {
                case frmLoadEvent:
                    if (event.data.frmLoad.formID == frmUISetting)
                    {
                        frmUISettingP = FrmInitForm(frmUISetting);
                        cbCustomCarrierP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, cbCustomCarrier);
                        cbShowDateTimeP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, cbShowDateTime);
                        cbAddMaskP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, cbAddMask);
                        cbAddLineP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, cbAddLine);
                        cbDrawOutlineP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, cbDrawOutline);
                        cbShowTopIconsP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, cbShowTopIcons);
                        cbShowTopProgramsP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, cbShowTopPrograms);
                        //lbPatternTypeP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, lbPatternType);
                        ptriPatternTypeP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, ptriPatternType);
                        lstPatternTypeP = (ListType *)GET_OBJECT_POINTER(frmUISettingP, lstPatternType);
                        ptriFocusRingStyleP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, ptriFocusRingStyle);
                        lstFocusRingStyleP = (ListType *)GET_OBJECT_POINTER(frmUISettingP, lstFocusRingStyle);
                        cbShowBackgdP = (ControlType *)GET_OBJECT_POINTER(frmUISettingP, cbShowBackgd);
                        FrmSetActiveForm(frmUISettingP);
                        isEventHandled = true;
                    }
                    break;
                case frmOpenEvent:
                    if (event.data.frmOpen.formID == frmUISetting)
                    {
                        //ÿؼ
                        FrmSetControlValue(frmUISettingP, FrmGetObjectIndex(frmUISettingP, pbtnUISetting2), 1);
                        CtlSetValue(cbCustomCarrierP, settingP->useCustomCarrier);
                        CtlSetValue(cbShowDateTimeP, settingP->shouldShowDateTime);
                        CtlSetValue(cbAddMaskP, settingP->shouldAddMask);
                        CtlSetValue(cbAddLineP, settingP->shouldAddLine);
                        CtlSetValue(cbDrawOutlineP, settingP->shouldDrawOutline);
                        CtlSetValue(cbShowTopIconsP, settingP->shouldShowTopIcons);
                        CtlSetValue(cbShowTopProgramsP, settingP->shouldShowTopPrograms);
                        LstSetSelection(lstPatternTypeP, getListSelectionFromPatternType(settingP->maskPattern));
                        CtlSetLabel(ptriPatternTypeP, LstGetSelectionText(lstPatternTypeP, LstGetSelection(lstPatternTypeP)));
                        LstSetSelection(lstFocusRingStyleP, settingP->focusRingStyle);
                        CtlSetLabel(ptriFocusRingStyleP, LstGetSelectionText(lstFocusRingStyleP, LstGetSelection(lstFocusRingStyleP)));
                        CtlSetValue(cbShowBackgdP, settingP->shouldShowBackgd);

                        //رղֲӦʾĿؼ
                        if (! settingP->useCustomCarrier)
                        {
                            CtlHideControl((ControlType *)GET_OBJECT_POINTER(frmUISettingP, btnCustomCarrier));
                        }
                        if (! settingP->shouldShowTopIcons)
                        {
                            CtlHideControl(cbShowTopProgramsP);
                        }
                        if (! settingP->shouldShowBackgd)
                        {
                            CtlHideControl((ControlType *)GET_OBJECT_POINTER(frmUISettingP, btnSetBackgd));
                        }
                        if (settingP->deviceModel == TREO_600)
                        {
                            CtlHideControl(cbShowBackgdP);
                        }

                        //
                        FrmDrawForm(frmUISettingP);

                        //
                        HsNavObjectTakeFocus(frmUISettingP, pbtnUISetting2);
                        isEventHandled = true;
                    }
                    break;
                case popSelectEvent:
                    if (event.data.popSelect.controlID == ptriFocusRingStyle)
                    {
                        if (settingP->deviceModel == TREO_600 && event.data.popSelect.selection > 2)
                        {
                            event.data.popSelect.selection = 0;
                            LstSetSelection(lstFocusRingStyleP, event.data.popSelect.selection);
                            CtlSetLabel(ptriFocusRingStyleP, LstGetSelectionText(lstFocusRingStyleP, LstGetSelection(lstFocusRingStyleP)));
                            FrmCustomAlert(alertInformation, STRING_FOCUS_RING_STYLE_NO_SUPPORT, "", "");
                            isEventHandled = true;
                        }
                    }
                    break;
                case ctlSelectEvent:
                    switch (event.data.ctlSelect.controlID)
                    {
                        case btnUIOK:
                            shouldExit = true;
                            returnCode = SETTING_EXIT;
                            isEventHandled = true;
                            break;
                        case pbtnGeneralSetting2:
                            shouldExit = true;
                            returnCode = SETTING_GENERAL;
                            isEventHandled = true;
                            break;
                        case pbtnColorSetting2:
                            shouldExit = true;
                            returnCode = SETTING_COLOR;
                            isEventHandled = true;
                            break;
                        case pbtnAdvanceSetting2:
                            shouldExit = true;
                            returnCode = SETTING_ADVANCE;
                            isEventHandled = true;
                            break;
                        case pbtnPluginSetting2:
                            shouldExit = true;
                            returnCode = SETTING_PLUGIN;
                            isEventHandled = true;
                            break;
                        case btnCustomCarrier:
                            frmCustomCarrierEventHandler(settingP);
                            isEventHandled = true;
                            break;
                        case btnSetBackgd:
                            if (! frmSetBackgroundEventHandler(settingP, globeP))
                            {
                                CtlSetValue(cbShowBackgdP, 0);
                                CtlHideControl((ControlType *)GET_OBJECT_POINTER(frmUISettingP, btnSetBackgd));
                            }
                            isEventHandled = true;
                            break;
                        case cbCustomCarrier:
                            if ((Boolean)CtlGetValue(cbCustomCarrierP))
                            {
                                CtlShowControl((ControlType *)GET_OBJECT_POINTER(frmUISettingP, btnCustomCarrier));
                            }
                            else
                            {
                                CtlHideControl((ControlType *)GET_OBJECT_POINTER(frmUISettingP, btnCustomCarrier));
                            }
                            break;
                        case cbShowBackgd:
                            if ((Boolean)CtlGetValue(cbShowBackgdP))
                            {
                                CtlShowControl((ControlType *)GET_OBJECT_POINTER(frmUISettingP, btnSetBackgd));
                            }
                            else
                            {
                                CtlHideControl((ControlType *)GET_OBJECT_POINTER(frmUISettingP, btnSetBackgd));
                            }
                            break;
                        case cbShowDateTime:
                            if (!(Boolean)CtlGetValue(cbShowDateTimeP))
                            {
                                settingP->shouldShowCalendar = false;
                            }
                            break;
                        case cbShowTopIcons:
                            if ((Boolean)CtlGetValue(cbShowTopIconsP))
                            {
                                CtlShowControl(cbShowTopProgramsP);
                            }
                            else
                            {
                                CtlSetValue(cbShowTopProgramsP, 0);
                                CtlHideControl(cbShowTopProgramsP);
                            }
                            break;
                        case cbAddMask:
                            if ((Boolean)CtlGetValue(cbAddMaskP))
                            {
                                CtlSetValue(cbAddLineP, 0);
                            }
                            break;
                        case cbAddLine:
                            if ((Boolean)CtlGetValue(cbAddLineP))
                            {
                                CtlSetValue(cbAddMaskP, 0);
                            }
                            break;
                    }
                    break;
            }

            if (! isEventHandled)
            {
                FrmDispatchEvent(&event);
            }
        }
    }while(event.eType != appStopEvent && (! shouldExit));

    //¼
    settingP->useCustomCarrier = CtlGetValue(cbCustomCarrierP);
    settingP->shouldShowDateTime = CtlGetValue(cbShowDateTimeP);
    settingP->shouldAddMask = CtlGetValue(cbAddMaskP);
    settingP->shouldAddLine = CtlGetValue(cbAddLineP);
    settingP->shouldDrawOutline = CtlGetValue(cbDrawOutlineP);
    settingP->shouldShowTopIcons = CtlGetValue(cbShowTopIconsP);
    settingP->shouldShowTopPrograms = CtlGetValue(cbShowTopProgramsP);
    settingP->maskPattern = getPatternTypeFromListSelection(LstGetSelection(lstPatternTypeP));
    settingP->focusRingStyle = LstGetSelection(lstFocusRingStyleP);
    settingP->shouldShowBackgd = CtlGetValue(cbShowBackgdP);

    FrmReturnToForm(0);
    PrefSetAppPreferences(APPLICATION_CREATOR, PREFERENCE_ID, PREFERENCE_VERSION, settingP, sizeof(SettingType), true);
    return returnCode;
}

#if 0
#pragma mark -
#pragma mark PROGRAM MANAGEMENT FUNCTIONS
#pragma mark -
#endif

Err getDatabaseNameByTypeCreator(UInt32 type, UInt32 creatorId, Char *nameP)
{
    UInt16              cardNo;
    LocalID             dbId;
    DmSearchStateType   dmSearchState;

    if (DmGetNextDatabaseByTypeCreator(true, &dmSearchState, type, creatorId, true, &cardNo, &dbId) == errNone)
    {
        return DmDatabaseInfo(cardNo, dbId, nameP, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    }

    return dmErrCantFind;
}

/*
void getProgramName(UInt32 type, UInt32 creatorId, Char *nameP)
{
    MemHandle       iconRscH    = DmGet1Resource('tAIN', 1000);

    if (iconRscH)
    {
        StrCopy(nameP, (Char *)MemHandleLock(iconRscH));
        MemHandleUnlock(iconRscH);
        DmReleaseResource(iconRscH);
    }
    else
    {
        if (getDatabaseNameByTypeCreator(type, creatorId, nameP) != errNone)
        {
            StrCopy(nameP, "-");
        }
    }
}
*/

#if 0
#pragma mark == PROGRAM CATEGORY AND SHORT CUT ==
#endif

//ȡڷеλ
static UInt16 getCategoryRecordId(UInt8 categoryId)
{
    UInt16              i;
    MemHandle           recordH;
    DmOpenRef           dbRef       = DmOpenDatabaseByTypeCreator(CATEGORY_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadOnly);
    UInt16              recordNum   = DmNumRecordsInCategory(dbRef, dmAllCategories);

    for (i = 0; i < recordNum; i ++)
    {
        recordH = DmQueryRecord(dbRef, i);
        if (((CategoryType *)MemHandleLock(recordH))->categoryId == categoryId)
        {
            MemHandleUnlock(recordH);
            break;
        }
        MemHandleUnlock(recordH);
    }

    DmCloseDatabase(dbRef);

    return i;
}

//Ƴб
static void programListManagementDrawItem(Int16 itemNum, RectangleType *boundsP, Char **itemsTextPP)
{
    Char                *categoryNameP;
    ListType            *lstProgramListCategoryP    = (ListType *)GET_OBJECT_POINTER(FrmGetActiveForm(), lstProgramListCategory);
    ProgramListType     **programListPP             = (ProgramListType **)itemsTextPP;
    Char                cacheP[32];
    RGBColorType        blueColor = {0, 0, 0, 255};
    RGBColorType        oldColor;

    //̶־
    if (programListPP[itemNum]->programNameP[0] != '\0')
    {
        StrCopy(cacheP, programListPP[itemNum]->programNameP);
    }
    else
    {
        cacheP[0] = '-';
        cacheP[1] = '\0';
    }

    //ÿϳΪɫ
    if (programListPP[itemNum]->VFSNameP[0] != '\0')
    {
        WinSetTextColorRGB(&blueColor, &oldColor);
    }

    if ((programListPP[itemNum]->addOnInfo & PROGRAM_LIST_STATIC_MASK))
    {
        WinDrawChar('*', boundsP->topLeft.x, boundsP->topLeft.y);
        WinDrawTruncChars(cacheP, StrLen(cacheP), boundsP->topLeft.x + 7, boundsP->topLeft.y, 66);
    }
    else
    {
        WinDrawTruncChars(cacheP, StrLen(cacheP), boundsP->topLeft.x, boundsP->topLeft.y, 73);
    }

    //ָɫ
    if (programListPP[itemNum]->VFSNameP[0] != '\0')
    {
        WinSetTextColorRGB(&oldColor, NULL);
    }

    //
    categoryNameP = LstGetSelectionText(lstProgramListCategoryP, (Int16)getCategoryRecordId(programListPP[itemNum]->categoryId));
    WinDrawTruncChars(categoryNameP, StrLen(categoryNameP), 81, boundsP->topLeft.y, 55);

    //ݼ
    if (programListPP[itemNum]->shortcut == chrNull)
    {
        WinDrawChar('-', 136, boundsP->topLeft.y);
    }
    else
    {
        WinDrawChar(programListPP[itemNum]->shortcut - 32, 136, boundsP->topLeft.y);
    }
}

//ݼǷظ
static Boolean isShortcutExist(ProgramListType **programListPP, UInt16 programListCount, Char shortcut)
{
    UInt16      i;

    for (i = 0; i < programListCount; i ++)
    {
        if (programListPP[i]->shortcut == shortcut)
        {
            return true;
        }
    }

    return false;
}

//дָĳ¼
static void writeProgramListItem(ProgramListType *programListItemP, UInt16 recordIdToWrite)
{
    DmOpenRef       dbRef   = DmOpenDatabaseByTypeCreator(PROGRAM_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);
    MemHandle       recordH = DmGetRecord(dbRef, recordIdToWrite);

    DmWrite((ProgramListType *)MemHandleLock(recordH), 0, programListItemP, sizeof(ProgramListType));
    MemHandleUnlock(recordH);
    DmReleaseRecord(dbRef, recordIdToWrite, true);
    DmCloseDatabase(dbRef);
}

//ƶ
static Boolean moveProgramInList(ProgramListType **programListPP, Int16 currentProgramIndex, Boolean isMoveUp)
{
    Boolean     done    = false;

    if (currentProgramIndex != noListSelection)
    {
        ProgramListType     *tmpP;
        MemHandle           recordH;
        DmOpenRef           dbRef           = DmOpenDatabaseByTypeCreator(PROGRAM_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);

        if (isMoveUp && currentProgramIndex > 0)
        {
            //Ƿ
            recordH = DmQueryRecord(dbRef, currentProgramIndex - 1);
            if (! (((ProgramListType *)MemHandleLock(recordH))->addOnInfo & PROGRAM_LIST_STATIC_MASK))  //ǹ̶
            {
                MemHandleUnlock(recordH);

                DmMoveRecord(dbRef, currentProgramIndex, currentProgramIndex - 1);

                tmpP = programListPP[currentProgramIndex];
                programListPP[currentProgramIndex] = programListPP[currentProgramIndex - 1];
                programListPP[currentProgramIndex - 1] = tmpP;

                done = true;
            }
            else
            {
                MemHandleUnlock(recordH);

                recordH = DmQueryRecord(dbRef, currentProgramIndex);
                if (((ProgramListType *)MemHandleLock(recordH))->addOnInfo & PROGRAM_LIST_STATIC_MASK)  //ǹ̶
                {
                    MemHandleUnlock(recordH);

                    DmMoveRecord(dbRef, currentProgramIndex, currentProgramIndex - 1);

                    tmpP = programListPP[currentProgramIndex];
                    programListPP[currentProgramIndex] = programListPP[currentProgramIndex - 1];
                    programListPP[currentProgramIndex - 1] = tmpP;

                    done = true;
                }
                else
                {
                    MemHandleUnlock(recordH);
                }
            }
        }
        else if ((! isMoveUp) && currentProgramIndex + 1 < DmNumRecordsInCategory(dbRef, dmAllCategories))
        {
            //Ƿ
            recordH = DmQueryRecord(dbRef, currentProgramIndex);

            if (! (((ProgramListType *)MemHandleLock(recordH))->addOnInfo & PROGRAM_LIST_STATIC_MASK))  //ǹ̶
            {
                MemHandleUnlock(recordH);

                DmMoveRecord(dbRef, currentProgramIndex, currentProgramIndex + 2);

                tmpP = programListPP[currentProgramIndex];
                programListPP[currentProgramIndex] = programListPP[currentProgramIndex + 1];
                programListPP[currentProgramIndex + 1] = tmpP;

                done = true;
            }
            else    //̶Ƿһ̶
            {
                MemHandleUnlock(recordH);

                recordH = DmQueryRecord(dbRef, currentProgramIndex + 1);
                if (((ProgramListType *)MemHandleLock(recordH))->addOnInfo & PROGRAM_LIST_STATIC_MASK)  //һǹ̶
                {
                    MemHandleUnlock(recordH);

                    DmMoveRecord(dbRef, currentProgramIndex, currentProgramIndex + 2);

                    tmpP = programListPP[currentProgramIndex];
                    programListPP[currentProgramIndex] = programListPP[currentProgramIndex + 1];
                    programListPP[currentProgramIndex + 1] = tmpP;

                    done = true;
                }
                else
                {
                    MemHandleUnlock(recordH);
                }
            }
        }

        DmCloseDatabase(dbRef);
    }

    return done;
}

//ù̶
static Int16 setProgramStatic(ProgramListType **programListPP, Int16 currentProgramIndex, Boolean shouldBeStatic)
{
    if (currentProgramIndex != noListSelection)
    {
        UInt16              i;
        ProgramListType     *tmpP;
        MemHandle           recordH;
        ProgramListType     *recordP;
        UInt16              lastStaticProgramIndex  = 0xFFFF;
        DmOpenRef           dbRef                   = DmOpenDatabaseByTypeCreator(PROGRAM_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);
        UInt16              programCount            = DmNumRecordsInCategory(dbRef, dmAllCategories);

        for(i = 0; i < programCount; i ++)
        {
            if ((programListPP[i]->addOnInfo & PROGRAM_LIST_STATIC_MASK))
            {
                lastStaticProgramIndex = i;
            }
            else
            {
                break;
            }
        }

        if (shouldBeStatic)
        {
            programListPP[currentProgramIndex]->addOnInfo |= PROGRAM_LIST_STATIC_MASK;

            recordH = DmGetRecord(dbRef, currentProgramIndex);
            recordP = (ProgramListType *)MemHandleLock(recordH);
            DmWrite(recordP, 0, programListPP[currentProgramIndex], sizeof(ProgramListType));
            MemHandleUnlock(recordH);
            DmReleaseRecord(dbRef, currentProgramIndex, true);

            if (lastStaticProgramIndex == 0xFFFF)
            {
                DmMoveRecord(dbRef, currentProgramIndex, 0);

                tmpP = programListPP[currentProgramIndex];
                lastStaticProgramIndex = 0;
            }
            else
            {
                DmMoveRecord(dbRef, currentProgramIndex, lastStaticProgramIndex + 1);

                tmpP = programListPP[currentProgramIndex];
                lastStaticProgramIndex ++;
            }

            for (i = currentProgramIndex; i > lastStaticProgramIndex; i --)
            {
                programListPP[i] = programListPP[i - 1];
            }
            programListPP[lastStaticProgramIndex] = tmpP;

            currentProgramIndex = lastStaticProgramIndex;
        }
        else
        {
            programListPP[currentProgramIndex]->addOnInfo &= (~PROGRAM_LIST_STATIC_MASK);

            recordH = DmGetRecord(dbRef, currentProgramIndex);
            recordP = (ProgramListType *)MemHandleLock(recordH);
            DmWrite(recordP, 0, programListPP[currentProgramIndex], sizeof(ProgramListType));
            MemHandleUnlock(recordH);
            DmReleaseRecord(dbRef, currentProgramIndex, true);

            if (lastStaticProgramIndex != 0xFFFF)
            {
                DmMoveRecord(dbRef, currentProgramIndex, lastStaticProgramIndex + 1);

                tmpP = programListPP[currentProgramIndex];
                for (i = currentProgramIndex; i < lastStaticProgramIndex; i ++)
                {
                    programListPP[i] = programListPP[i + 1];
                }
                programListPP[lastStaticProgramIndex] = tmpP;
                currentProgramIndex = lastStaticProgramIndex;
            }
        }

        DmCloseDatabase(dbRef);
    }

    return currentProgramIndex;
}

//óݼ
static void programCategoryAndShortCut(GlobeType *globeP)
{
    FormType            *frmProgramListManagementP;
    ListType            *lstProgramListP;
    ControlType         *cbProgramStaticP;
    ControlType         *ptriProgramListCategoryP;
    ListType            *lstProgramListCategoryP;
    EventType           event;
    UInt16              i;
    Char                chr;
    DmOpenRef           dbRef;
    MemHandle           recordH;
    Char                **categoryNamePP;
    UInt16              categoryCount;
    ProgramListType     **programListPP;
    UInt16              programListCount;
    Boolean             isEventHandled;
    Boolean             shouldExit          = false;

    FrmPopupForm(frmProgramListManagement);

    do
    {
        EvtGetEvent(&event, evtWaitForever);

        isEventHandled = false;
        if (! SysHandleEvent(&event))
        {
            switch (event.eType)
            {
                case frmLoadEvent:
                    if (event.data.frmLoad.formID == frmProgramListManagement)
                    {
                        frmProgramListManagementP = FrmInitForm(frmProgramListManagement);
                        lstProgramListP = (ListType *)GET_OBJECT_POINTER(frmProgramListManagementP, lstProgramList);
                        cbProgramStaticP = (ControlType *)GET_OBJECT_POINTER(frmProgramListManagementP, cbProgramStatic);
                        ptriProgramListCategoryP = (ControlType *)GET_OBJECT_POINTER(frmProgramListManagementP, ptriProgramListCategory);
                        lstProgramListCategoryP = (ListType *)GET_OBJECT_POINTER(frmProgramListManagementP, lstProgramListCategory);

                        FrmSetActiveForm(frmProgramListManagementP);
                        isEventHandled = true;
                    }
                    break;
                case frmOpenEvent:
                    if (event.data.frmOpen.formID == frmProgramListManagement)
                    {
                        //ȡб
                        dbRef = DmOpenDatabaseByTypeCreator(CATEGORY_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadOnly);
                        categoryCount = DmNumRecordsInCategory(dbRef, dmAllCategories);
                        categoryNamePP = (Char **)MemPtrNew(4 * categoryCount);
                        for (i = 0; i < categoryCount; i ++)
                        {
                            recordH = DmQueryRecord(dbRef, i);
                            categoryNamePP[i] = (Char *)MemPtrNew(16);
                            StrCopy(categoryNamePP[i], ((CategoryType *)MemHandleLock(recordH))->nameP);
                            MemHandleUnlock(recordH);
                        }
                        DmCloseDatabase(dbRef);

                        //ȡб
                        dbRef = DmOpenDatabaseByTypeCreator(PROGRAM_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadOnly);
                        programListCount = DmNumRecordsInCategory(dbRef, dmAllCategories);
                        programListPP = (ProgramListType **)MemPtrNew(4 * programListCount);
                        for (i = 0; i < programListCount; i ++)
                        {
                            recordH = DmQueryRecord(dbRef, i);
                            programListPP[i] = (ProgramListType *)MemPtrNew(sizeof(ProgramListType));
                            MemMove(programListPP[i], ((ProgramListType *)MemHandleLock(recordH)), sizeof(ProgramListType));
                            MemHandleUnlock(recordH);
                        }
                        DmCloseDatabase(dbRef);

                        //÷б
                        LstSetListChoices(lstProgramListCategoryP, categoryNamePP, categoryCount);
                        LstSetHeight(lstProgramListCategoryP, categoryCount);
                        LstSetPosition(lstProgramListCategoryP, 84, 119 - categoryCount * 11);

                        //óб
                        LstSetDrawFunction(lstProgramListP, programListManagementDrawItem);
                        LstSetListChoices(lstProgramListP, (Char **)programListPP, programListCount);
                        LstSetSelection(lstProgramListP, 0);
                        LstSetSelection(lstProgramListCategoryP, (Int16)getCategoryRecordId(programListPP[0]->categoryId));
                        CtlSetLabel(ptriProgramListCategoryP, LstGetSelectionText(lstProgramListCategoryP, LstGetSelection(lstProgramListCategoryP)));

                        FrmDrawForm(frmProgramListManagementP);
                        isEventHandled = true;
                    }
                    break;
                case lstSelectEvent:
                    if (event.data.lstSelect.listID == lstProgramList)
                    {
                        LstSetSelection(lstProgramListCategoryP, (Int16)getCategoryRecordId(programListPP[event.data.lstSelect.selection]->categoryId));
                        CtlSetLabel(ptriProgramListCategoryP, LstGetSelectionText(lstProgramListCategoryP, LstGetSelection(lstProgramListCategoryP)));
                        if ((programListPP[event.data.lstSelect.selection]->addOnInfo & PROGRAM_LIST_STATIC_MASK))
                        {
                            CtlSetValue(cbProgramStaticP, 1);
                        }
                        else
                        {
                            CtlSetValue(cbProgramStaticP, 0);
                        }
                    }
                    break;
                case popSelectEvent:
                    if (event.data.popSelect.listID == lstProgramListCategory && event.data.popSelect.selection != noListSelection)
                    {
                        dbRef = DmOpenDatabaseByTypeCreator(CATEGORY_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadOnly);
                        recordH = DmQueryRecord(dbRef, event.data.popSelect.selection);
                        i = LstGetSelection(lstProgramListP);
                        programListPP[i]->categoryId = ((CategoryType *)MemHandleLock(recordH))->categoryId;
                        MemHandleUnlock(recordH);
                        DmCloseDatabase(dbRef);
                        writeProgramListItem(programListPP[i], i);
                        LstDrawList(lstProgramListP);
                    }
                    break;
                case ctlSelectEvent:
                    switch (event.data.ctlSelect.controlID)
                    {
                        case btnProgramMoveUp:
                            if (moveProgramInList(programListPP, LstGetSelection(lstProgramListP), true))
                            {
                                LstSetSelection(lstProgramListP, LstGetSelection(lstProgramListP) - 1);
                                LstDrawList(lstProgramListP);
                            }
                            break;
                        case btnProgramMoveDown:
                            if (moveProgramInList(programListPP, LstGetSelection(lstProgramListP), false))
                            {
                                LstSetSelection(lstProgramListP, LstGetSelection(lstProgramListP) + 1);
                                LstDrawList(lstProgramListP);
                            }
                            break;
                        case cbProgramStatic:
                            if (LstGetSelection(lstProgramListP) != noListSelection)
                            {
                                LstSetSelection(lstProgramListP, setProgramStatic(programListPP, LstGetSelection(lstProgramListP), (Boolean)CtlGetValue(cbProgramStaticP)));
                                LstDrawList(lstProgramListP);
                            }
                            else
                            {
                                CtlSetValue(cbProgramStaticP, 0);
                            }
                            break;
                        case btnSetProgramShortcut:
                            i = LstGetSelection(lstProgramListP);
                            chr = (Char)customKey();
                            if ((chr < keyA || chr > keyZ) && chr != keyBackspace)
                            {
                                FrmCustomAlert(alertError, STRING_SHORTCUT_CHARACTER_ERROR, "", "");
                            }
                            else if (isShortcutExist(programListPP, programListCount, chr))
                            {
                                FrmCustomAlert(alertError, STRING_SHORTCUT_EXIST_ERROR, "", "");
                            }
                            else
                            {
                                if (chr == keyBackspace)
                                {
                                    chr = chrNull;
                                }
                                programListPP[i]->shortcut = chr;
                                writeProgramListItem(programListPP[i], i);
                                LstDrawList(lstProgramListP);
                            }
                            break;
                        case btnClearProgramShortcut:
                            if (FrmCustomAlert(alertConfirmation, STRING_CLEAR_SHORTCUT_CONFIRM, "", "") == 0)
                            {
                                i = LstGetSelection(lstProgramListP);
                                programListPP[i]->shortcut = chrNull;
                                writeProgramListItem(programListPP[i], i);
                                LstDrawList(lstProgramListP);
                            }
                            break;
                        case btnManagementOK:
                            shouldExit = true;
                            isEventHandled = true;
                            break;
                    }
                    break;
            }

            if (! isEventHandled)
            {
                FrmDispatchEvent(&event);
            }
        }
    }while (event.eType != appStopEvent && shouldExit == false);

    for (i = 0; i < programListCount; i ++)
    {
        MemPtrFree(programListPP[i]);
    }
    MemPtrFree(programListPP);

    for (i = 0; i < categoryCount; i ++)
    {
        MemPtrFree(categoryNamePP[i]);
    }
    MemPtrFree(categoryNamePP);

    FrmReturnToForm(0);
}

#if 0
#pragma mark == PROGRAM CATEGORY MANAGEMENT ==
#endif

//ɾ
static void performCategoryDelete(Int16 listId/*, GlobeType *globeP*/)
{
    if (listId != noListSelection)
    {
        UInt16          i;
        UInt16          programCount;
        ProgramListType *programP;
        ProgramListType *tmpProgramP    = (ProgramListType *)MemPtrNew(sizeof(ProgramListType));
        //ɾ¼
        DmOpenRef       dbRef           = DmOpenDatabaseByTypeCreator(CATEGORY_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);
        MemHandle       recordH         = DmQueryRecord(dbRef, listId + 1);
        UInt8           categoryId      = ((CategoryType *)MemHandleLock(recordH))->categoryId;

        MemHandleUnlock(recordH);
        DmRemoveRecord(dbRef, listId + 1);
        DmCloseDatabase(dbRef);

        //
        dbRef = DmOpenDatabaseByTypeCreator(PROGRAM_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);
        programCount = DmNumRecordsInCategory(dbRef, dmAllCategories);

        for (i = 0; i < programCount; i ++)
        {
            recordH = DmGetRecord(dbRef, i);
            programP = (ProgramListType *)MemHandleLock(recordH);

            if (programP->categoryId == categoryId)
            {
                MemMove(tmpProgramP, programP, sizeof(ProgramListType));
                tmpProgramP->categoryId = 0;
                DmWrite(programP, 0, tmpProgramP, sizeof(ProgramListType));
            }

            MemHandleUnlock(recordH);
            DmReleaseRecord(dbRef, i, true);
        }

        DmCloseDatabase(dbRef);
        MemPtrFree(tmpProgramP);
    }
}

//ʾط
static void performCategoryShowHide(Int16 selection, Boolean shouldShow)
{
    if (selection != noListSelection)
    {
        DmOpenRef       dbRef           = DmOpenDatabaseByTypeCreator(CATEGORY_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);
        MemHandle       recordH         = DmGetRecord(dbRef, selection + 1);
        CategoryType    *recordP        = (CategoryType *)MemHandleLock(recordH);
        CategoryType    *tmpRecordP     = (CategoryType *)MemPtrNew(sizeof(CategoryType));

        MemMove(tmpRecordP, recordP, sizeof(CategoryType));

        tmpRecordP->isCategoryHide = (! shouldShow);

        DmWrite(recordP, 0, tmpRecordP, sizeof(CategoryType));

        MemPtrFree(tmpRecordP);
        MemHandleUnlock(recordH);
        DmReleaseRecord(dbRef, selection + 1, true);
        DmCloseDatabase(dbRef);
    }
}

//
static void performCategoryRename(Int16 listId)
{
    if (listId != noListSelection)
    {
        Char        newNameP[16]    = "";

        if (FrmCustomResponseAlert(alertCategoryName, "", "", "", newNameP, 15, NULL) == 0)
        {
            if ((UInt8)newNameP[0] != 0)
            {
                DmOpenRef       dbRef           = DmOpenDatabaseByTypeCreator(CATEGORY_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);
                MemHandle       recordH         = DmGetRecord(dbRef, listId + 1);
                CategoryType    *recordP        = (CategoryType *)MemHandleLock(recordH);
                CategoryType    *tmpRecordP     = (CategoryType *)MemPtrNew(sizeof(CategoryType));

                MemMove(tmpRecordP, recordP, sizeof(CategoryType));
                StrCopy(tmpRecordP->nameP, newNameP);
                DmWrite(recordP, 0, tmpRecordP, sizeof(CategoryType));

                MemPtrFree(tmpRecordP);
                MemHandleUnlock(recordH);
                DmReleaseRecord(dbRef, listId + 1, true);
                DmCloseDatabase(dbRef);
            }
        }
    }
}

//Ƿ
static Boolean isCategoryIdExist(UInt8 categoryId, DmOpenRef dbRef, UInt16 recordNums)
{
    UInt16          i;
    MemHandle       recordH;
    Boolean         isExist     = false;

    for (i = 0; i < recordNums; i ++)
    {
        recordH = DmQueryRecord(dbRef, i);

        if (((CategoryType *)MemHandleLock(recordH))->categoryId == categoryId)
        {
            isExist = true;
            MemHandleUnlock(recordH);
            break;
        }
        else
        {
            MemHandleUnlock(recordH);
        }
    }

    return isExist;
}

//
static void performCategoryNew()
{
    Char        newNameP[16]    = "";

    if (FrmCustomResponseAlert(alertCategoryName, "", "", "", newNameP, 15, NULL) == 0)
    {
        if ((UInt8)newNameP[0] != 0)
        {
            UInt16          i;
            MemHandle       recordH;
            DmOpenRef       dbRef           = DmOpenDatabaseByTypeCreator(CATEGORY_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadWrite);
            UInt16          recordNums      = DmNumRecordsInCategory(dbRef, dmAllCategories);
            CategoryType    *newRecordP     = (CategoryType *)MemPtrNew(sizeof(CategoryType));

            MemSet(newRecordP, sizeof(CategoryType), 0);
            StrCopy(newRecordP->nameP, newNameP);

            for (newRecordP->categoryId = 0; newRecordP->categoryId < 0xFF; newRecordP->categoryId ++)
            {
                if (! isCategoryIdExist(newRecordP->categoryId, dbRef, recordNums))
                {
                    i = dmMaxRecordIndex;

                    recordH = DmNewRecord(dbRef, &i, sizeof(CategoryType));
                    DmWrite((CategoryType *)MemHandleLock(recordH), 0, newRecordP, sizeof(CategoryType));

                    MemHandleUnlock(recordH);
                    DmReleaseRecord(dbRef, i, true);
                    break;
                }
            }

            MemPtrFree(newRecordP);
            DmCloseDatabase(dbRef);
        }
    }
}

static void programCategoryDrawItem(Int16 itemNum, RectangleType *boundsP, Char **itemsTextPP)
{
    CategoryType        **categoryPP        = (CategoryType **)itemsTextPP;

    if (categoryPP[itemNum]->isCategoryHide)
    {
        WinDrawChar('*', boundsP->topLeft.x, boundsP->topLeft.y);
        WinDrawTruncChars(categoryPP[itemNum]->nameP, StrLen(categoryPP[itemNum]->nameP), boundsP->topLeft.x + 8, boundsP->topLeft.y, boundsP->extent.x - 8);
    }
    else
    {
        WinDrawTruncChars(categoryPP[itemNum]->nameP, StrLen(categoryPP[itemNum]->nameP), boundsP->topLeft.x, boundsP->topLeft.y, boundsP->extent.x);
    }
}

//
static void programCategory(GlobeType *globeP, SettingType *settingP)
{
    FormType            *frmProgramCategoryP;
    ListType            *lstProgramCategoryP;
    ControlType         *btnProgramCategoryHideP;
    ControlType         *btnProgramCategoryShowP;
    EventType           event;
    DmOpenRef           dbRef;
    MemHandle           recordH;
    CategoryType        **categoryPP;
    UInt16              categoryCount;
    UInt16              i;
    Boolean             isEventHandled;
    Boolean             shouldExit              = false;

    FrmPopupForm(frmProgramCategory);

    do
    {
        EvtGetEvent(&event, evtWaitForever);

        isEventHandled = false;

        if (! SysHandleEvent(&event))
        {
            switch (event.eType)
            {
                case frmLoadEvent:
                    if (event.data.frmLoad.formID == frmProgramCategory)
                    {
                        frmProgramCategoryP = FrmInitForm(frmProgramCategory);
                        lstProgramCategoryP = (ListType *)GET_OBJECT_POINTER(frmProgramCategoryP, lstProgramCategory);
                        btnProgramCategoryHideP = (ControlType *)GET_OBJECT_POINTER(frmProgramCategoryP, btnProgramCategoryHide);
                        btnProgramCategoryShowP = (ControlType *)GET_OBJECT_POINTER(frmProgramCategoryP, btnProgramCategoryShow);
                        FrmSetActiveForm(frmProgramCategoryP);
                        isEventHandled = true;
                    }
                    break;
                case frmOpenEvent:
                    if (event.data.frmOpen.formID == frmProgramCategory)
                    {
                        //ȡб
                        dbRef = DmOpenDatabaseByTypeCreator(CATEGORY_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadOnly);
                        categoryCount = DmNumRecordsInCategory(dbRef, dmAllCategories);
                        categoryPP = (CategoryType **)MemPtrNew(4 * categoryCount);
                        for (i = 1; i < categoryCount; i ++)
                        {
                            recordH = DmQueryRecord(dbRef, i);
                            categoryPP[i - 1] = (CategoryType *)MemPtrNew(sizeof(CategoryType));
                            MemMove(categoryPP[i - 1], (CategoryType *)MemHandleLock(recordH), sizeof(CategoryType));
                            MemHandleUnlock(recordH);
                        }
                        DmCloseDatabase(dbRef);

                        LstSetDrawFunction(lstProgramCategoryP, programCategoryDrawItem);
                        LstSetListChoices(lstProgramCategoryP, (Char **)categoryPP, categoryCount - 1);

                        FrmDrawForm(frmProgramCategoryP);

                        if (categoryCount > 1)
                        {
                            LstSetSelection(lstProgramCategoryP, 0);
                            if (categoryPP[0]->isCategoryHide)
                            {
                                CtlShowControl(btnProgramCategoryShowP);
                                CtlHideControl(btnProgramCategoryHideP);
                                CtlDrawControl(btnProgramCategoryShowP);
                            }
                            else
                            {
                                CtlHideControl(btnProgramCategoryShowP);
                                CtlShowControl(btnProgramCategoryHideP);
                                CtlDrawControl(btnProgramCategoryHideP);
                            }
                        }
                        else
                        {
                            LstSetSelection(lstProgramCategoryP, noListSelection);
                            CtlHideControl(btnProgramCategoryShowP);
                            CtlHideControl(btnProgramCategoryHideP);
                        }

                        isEventHandled = true;
                    }
                    break;
                case lstSelectEvent:
                    if (event.data.lstSelect.selection)
                    {
                        if (categoryPP[event.data.lstSelect.selection]->isCategoryHide)
                        {
                            CtlShowControl(btnProgramCategoryShowP);
                            CtlHideControl(btnProgramCategoryHideP);
                            CtlDrawControl(btnProgramCategoryShowP);
                        }
                        else
                        {
                            CtlHideControl(btnProgramCategoryShowP);
                            CtlShowControl(btnProgramCategoryHideP);
                            CtlDrawControl(btnProgramCategoryHideP);
                        }
                    }
                    break;
                case ctlSelectEvent:
                    switch (event.data.ctlSelect.controlID)
                    {
                        case btnProgramCategoryNew:
                            performCategoryNew();
                            isEventHandled = true;
                            break;
                        case btnProgramCategoryRename:
                            performCategoryRename(LstGetSelection(lstProgramCategoryP));
                            isEventHandled = true;
                            break;
                        case btnProgramCategoryDelete:
                            if (FrmCustomAlert(alertConfirmation, STRING_CONFIRM_DELETE_CATEGORY, "", "") == 0)
                            {
                                performCategoryDelete(LstGetSelection(lstProgramCategoryP));
                            }
                            isEventHandled = true;
                            break;
                        case btnProgramCategoryHide:
                            performCategoryShowHide(LstGetSelection(lstProgramCategoryP), false);
                            isEventHandled = true;
                            break;
                        case btnProgramCategoryShow:
                            performCategoryShowHide(LstGetSelection(lstProgramCategoryP), true);
                            isEventHandled = true;
                            break;
                        case btnProgramCategoryOK:
                            shouldExit = true;
                            isEventHandled = true;
                            break;
                    }

                    //ˢ·б
                    LstSetListChoices(lstProgramCategoryP, NULL, 0);
                    categoryCount --;
                    for (i = 0; i < categoryCount; i ++)
                    {
                        MemPtrFree(categoryPP[i]);
                    }
                    MemPtrFree(categoryPP);

                    dbRef = DmOpenDatabaseByTypeCreator(CATEGORY_LIST_DB_TYPE, APPLICATION_CREATOR, dmModeReadOnly);
                    categoryCount = DmNumRecordsInCategory(dbRef, dmAllCategories);
                    categoryPP = (CategoryType **)MemPtrNew(4 * categoryCount);
                    for (i = 1; i < categoryCount; i ++)
                    {
                        recordH = DmQueryRecord(dbRef, i);
                        categoryPP[i - 1] = (CategoryType *)MemPtrNew(sizeof(CategoryType));
                        MemMove(categoryPP[i - 1], (CategoryType *)MemHandleLock(recordH), sizeof(CategoryType));
                        MemHandleUnlock(recordH);
                    }
                    DmCloseDatabase(dbRef);

                    LstSetDrawFunction(lstProgramCategoryP, programCategoryDrawItem);
                    LstSetListChoices(lstProgramCategoryP, (Char **)categoryPP, categoryCount - 1);

                    if (categoryCount > 1)
                    {
                        LstSetSelection(lstProgramCategoryP, 0);
                        if (categoryPP[0]->isCategoryHide)
                        {
                            CtlShowControl(btnProgramCategoryShowP);
                            CtlHideControl(btnProgramCategoryHideP);
                            CtlDrawControl(btnProgramCategoryShowP);
                        }
                        else
                        {
                            CtlHideControl(btnProgramCategoryShowP);
                            CtlShowControl(btnProgramCategoryHideP);
                            CtlDrawControl(btnProgramCategoryHideP);
                        }
                    }
                    else
                    {
                        LstSetSelection(lstProgramCategoryP, noListSelection);
                        CtlHideControl(btnProgramCategoryShowP);
                        CtlHideControl(btnProgramCategoryHideP);
                    }

                    LstDrawList(lstProgramCategoryP);
                    break;
            }

            if (! isEventHandled)
            {
                FrmDispatchEvent(&event);
            }
        }
    } while (event.eType != appStopEvent && shouldExit != true);

    FrmReturnToForm(0);

    categoryCount --;
    for (i = 0; i < categoryCount; i ++)
    {
        MemPtrFree(categoryPP[i]);
    }
    MemPtrFree(categoryPP);
}

#if 0
#pragma mark == PROGRAM MANAGEMENT CALLING ==
#endif

void programManagement(GlobeType *globeP, UInt8 type, SettingType *settingP)
{
    switch (type)
    {
        case MANAGEMENT_CATEGORY_AND_SHORT_CUT:
            programCategoryAndShortCut(globeP);
            break;
        case MANAGEMENT_CATEGORY:
            programCategory(globeP, settingP);
            break;
    }
}

#if 0
#pragma mark -
#pragma mark PROFILE FUNCTIONS
#pragma mark -
#endif

void profileManagement(SettingType *settingP, Boolean shouldGetDefaultSetting)
{
    UInt16          tonesLibRef;

    if (SysLibLoad(tonesLibType, tonesLibCreator, &tonesLibRef) == errNone)
    {
        Int32               i;
        SoundPreference     soundPrefs;

        TonesLibOpen(tonesLibRef);

        if (shouldGetDefaultSetting)
        {
            MemSet(&settingP->profiles[0], sizeof(ProfileType), 0);
            StrCopy(settingP->profiles[0].nameP, STRING_PROFILE_NORMAL);
            for (i = 1; i < 5; i ++)
            {
                MemSet(&settingP->profiles[i], sizeof(ProfileType), 0);
                StrCopy(settingP->profiles[i].nameP, STRING_PROFILE_UNDEFINE);
            }

            for (i = soundPrefTypePhone; i < soundPrefTypeLast; i ++)
            {
                TonesLibGetSoundPrefs(tonesLibRef, i, &soundPrefs);

                switch (i)
                {
                    case soundPrefTypePhone:
                        settingP->profiles[0].phoneSoundPrefs.tonePrefs.phoneSoundPrefs = soundPrefs.tonePrefs.phoneSoundPrefs;
                        settingP->profiles[0].phoneSoundPrefs.soundOnVolume = soundPrefs.soundOnVolume;
                        settingP->profiles[0].phoneSoundPrefs.soundOnVibrate = soundPrefs.soundOnVibrate;
                        settingP->profiles[0].phoneSoundPrefs.soundOffVibrate = soundPrefs.soundOffVibrate;
                        break;
                    case soundPrefTypeEmail:
                        break;
                    case soundPrefTypeCalendar:
                        settingP->profiles[0].calendarSoundPrefs.tonePrefs.calendarSoundPrefs = soundPrefs.tonePrefs.calendarSoundPrefs;
                        settingP->profiles[0].calendarSoundPrefs.soundOnVolume = soundPrefs.soundOnVolume;
                        settingP->profiles[0].calendarSoundPrefs.soundOnVibrate = soundPrefs.soundOnVibrate;
                        settingP->profiles[0].calendarSoundPrefs.soundOffVibrate = soundPrefs.soundOffVibrate;
                        break;
                    case soundPrefTypeIM:
                        break;
                    case soundPrefTypeMMS:
                        break;
                    case soundPrefTypeSMS:
                        settingP->profiles[0].smsSoundPrefs.tonePrefs.smsSoundPrefs = soundPrefs.tonePrefs.smsSoundPrefs;
                        settingP->profiles[0].smsSoundPrefs.soundOnVolume = soundPrefs.soundOnVolume;
                        settingP->profiles[0].smsSoundPrefs.soundOnVibrate = soundPrefs.soundOnVibrate;
                        settingP->profiles[0].smsSoundPrefs.soundOffVibrate = soundPrefs.soundOffVibrate;
                        break;
                }
            }
        }
        else
        {
            EventType       event;
            FormType        *frmProfileManagementP;
            ControlType     *ptriProfileManagementP;
            ListType        *lstProfileManagementP;
            FieldType       *fldProfileNameP;
            ControlType     *ptriProfileRingTypeP;
            ListType        *lstProfileRingTypeP;
            ControlType     *ptriProfileVolumeP;
            ListType        *lstProfileVolumeP;
            ControlType     *cbProfileVibrateONP;
            ControlType     *cbProfileVibrateOFFP;
            ControlType     *cbProfileMuteVibrateONP;
            ControlType     *cbProfileMuteVibrateOFFP;
            SoundPreference *soundPrefsP;
            Char            **profileNamePP = NULL;
            Boolean         isEventHandled;
            Boolean         shouldIgnoreFieldChanged    = false;
            Boolean         shouldExit                  = false;

            FrmPopupForm(frmProfileManagement);

            do
            {
                EvtGetEvent(&event, evtWaitForever);

                isEventHandled = false;
                if (! SysHandleEvent(&event))
                {
                    switch (event.eType)
                    {
                        case frmLoadEvent:
                            if (event.data.frmLoad.formID == frmProfileManagement)
                            {
                                frmProfileManagementP = FrmInitForm(frmProfileManagement);
                                FrmSetActiveForm(frmProfileManagementP);

                                ptriProfileManagementP = (ControlType *)GET_OBJECT_POINTER(frmProfileManagementP, ptriProfileManagement);
                                lstProfileManagementP = (ListType *)GET_OBJECT_POINTER(frmProfileManagementP, lstProfileManagement);
                                fldProfileNameP = (FieldType *)GET_OBJECT_POINTER(frmProfileManagementP, fldProfileName);
                                ptriProfileRingTypeP = (ControlType *)GET_OBJECT_POINTER(frmProfileManagementP, ptriProfileRingType);
                                lstProfileRingTypeP = (ListType *)GET_OBJECT_POINTER(frmProfileManagementP, lstProfileRingType);
                                ptriProfileVolumeP = (ControlType *)GET_OBJECT_POINTER(frmProfileManagementP, ptriProfileVolume);
                                lstProfileVolumeP = (ListType *)GET_OBJECT_POINTER(frmProfileManagementP, lstProfileVolume);
                                cbProfileVibrateONP = (ControlType *)GET_OBJECT_POINTER(frmProfileManagementP, cbProfileVibrateON);
                                cbProfileVibrateOFFP = (ControlType *)GET_OBJECT_POINTER(frmProfileManagementP, cbProfileVibrateOFF);
                                cbProfileMuteVibrateONP = (ControlType *)GET_OBJECT_POINTER(frmProfileManagementP, cbProfileMuteVibrateON);
                                cbProfileMuteVibrateOFFP = (ControlType *)GET_OBJECT_POINTER(frmProfileManagementP, cbProfileMuteVibrateOFF);

                                profileNamePP = (Char **)MemPtrNew(20); //5 sizeof(Char *)
                                if (profileNamePP == NULL)
                                    break;  //doѭ
                                MemSet(profileNamePP, 20, 0);

                                for (i = 0; i < 5; i ++)
                                {
                                    profileNamePP[i] = (Char *)MemPtrNew(21);  //sizeof(Char)
                                    if (profileNamePP[i] == NULL)
                                        break;
                                    StrCopy(profileNamePP[i], settingP->profiles[i].nameP);
                                }
                                if (i < 5)
                                    break;  //doѭ

                                LstSetListChoices(lstProfileManagementP, profileNamePP, 5);

                                isEventHandled = true;
                            }
                            break;
                        case frmOpenEvent:
                            if (event.data.frmLoad.formID == frmProfileManagement)
                            {
                                LstSetSelection(lstProfileManagementP, 0);
                                CtlSetLabel(ptriProfileManagementP, LstGetSelectionText(lstProfileManagementP, 0));

                                LstSetSelection(lstProfileRingTypeP, 0);
                                CtlSetLabel(ptriProfileRingTypeP, LstGetSelectionText(lstProfileRingTypeP, 0));

                                LstSetSelection(lstProfileVolumeP, settingP->profiles[0].phoneSoundPrefs.soundOnVolume);
                                CtlSetLabel(ptriProfileVolumeP, LstGetSelectionText(lstProfileVolumeP, settingP->profiles[0].phoneSoundPrefs.soundOnVolume));

                                if (settingP->profiles[0].phoneSoundPrefs.soundOnVibrate)
                                {
                                    CtlSetValue(cbProfileVibrateONP, 1);
                                }
                                else
                                {
                                    CtlSetValue(cbProfileVibrateOFFP, 1);
                                }

                                if (settingP->profiles[0].phoneSoundPrefs.soundOffVibrate)
                                {
                                    CtlSetValue(cbProfileMuteVibrateONP, 1);
                                }
                                else
                                {
                                    CtlSetValue(cbProfileMuteVibrateOFFP, 1);
                                }

                                FrmDrawForm(frmProfileManagementP);

                                FldInsert(fldProfileNameP, settingP->profiles[0].nameP, StrLen(settingP->profiles[0].nameP));
                                shouldIgnoreFieldChanged = true;

                                isEventHandled = true;
                            }
                            break;
                        case fldChangedEvent:
                            if (! shouldIgnoreFieldChanged)
                            {
                                i = LstGetSelection(lstProfileManagementP);

                                if (i != noListSelection)
                                {
                                    LstSetListChoices(lstProfileManagementP, NULL, 0);

                                    if (FldGetTextLength(fldProfileNameP) == 0)
                                    {
                                        StrCopy(settingP->profiles[i].nameP, STRING_PROFILE_UNDEFINE);
                                        StrCopy(profileNamePP[i], STRING_PROFILE_UNDEFINE);
                                    }
                                    else
                                    {
                                        StrCopy(settingP->profiles[i].nameP, FldGetTextPtr(fldProfileNameP));
                                        StrCopy(profileNamePP[i], settingP->profiles[i].nameP);
                                    }

                                    LstSetListChoices(lstProfileManagementP, profileNamePP, 5);
                                    LstSetSelection(lstProfileManagementP, i);
                                    CtlSetLabel(ptriProfileManagementP, LstGetSelectionText(lstProfileManagementP, i));

                                    isEventHandled = true;
                                }
                            }
                            else
                            {
                                shouldIgnoreFieldChanged = false;
                            }
                            break;
                        case popSelectEvent:
                            switch (event.data.popSelect.controlID)
                            {
                                case ptriProfileManagement:
                                    if (event.data.popSelect.selection != noListSelection)
                                    {
                                        LstSetSelection(lstProfileRingTypeP, 0);
                                        CtlSetLabel(ptriProfileRingTypeP, LstGetSelectionText(lstProfileRingTypeP, 0));

                                        LstSetSelection(lstProfileVolumeP, settingP->profiles[event.data.popSelect.selection].phoneSoundPrefs.soundOnVolume);
                                        CtlSetLabel(ptriProfileVolumeP, LstGetSelectionText(lstProfileVolumeP, settingP->profiles[event.data.popSelect.selection].phoneSoundPrefs.soundOnVolume));

                                        CtlShowControl(cbProfileVibrateONP);
                                        CtlShowControl(cbProfileVibrateOFFP);
                                        CtlShowControl(cbProfileMuteVibrateONP);
                                        CtlShowControl(cbProfileMuteVibrateOFFP);
                                        if (settingP->profiles[event.data.popSelect.selection].phoneSoundPrefs.soundOnVibrate)
                                        {
                                            CtlSetValue(cbProfileVibrateONP, 1);
                                            CtlSetValue(cbProfileVibrateOFFP, 0);
                                        }
                                        else
                                        {
                                            CtlSetValue(cbProfileVibrateONP, 0);
                                            CtlSetValue(cbProfileVibrateOFFP, 1);
                                        }
                                        if (settingP->profiles[event.data.popSelect.selection].phoneSoundPrefs.soundOffVibrate)
                                        {
                                            CtlSetValue(cbProfileMuteVibrateONP, 1);
                                            CtlSetValue(cbProfileMuteVibrateOFFP, 0);
                                        }
                                        else
                                        {
                                            CtlSetValue(cbProfileMuteVibrateONP, 0);
                                            CtlSetValue(cbProfileMuteVibrateOFFP, 1);
                                        }

                                        shouldIgnoreFieldChanged = true;
                                        FldDelete(fldProfileNameP, 0, 20);
                                        FldInsert(fldProfileNameP, settingP->profiles[event.data.popSelect.selection].nameP, StrLen(settingP->profiles[event.data.popSelect.selection].nameP));
                                    }
                                    break;
                                case ptriProfileRingType:
                                    i = LstGetSelection(lstProfileManagementP);
                                    if (i != noListSelection)
                                    {
                                        switch(event.data.popSelect.selection)
                                        {
                                            case 0:     //绰
                                                CtlShowControl(cbProfileVibrateONP);
                                                CtlShowControl(cbProfileVibrateOFFP);
                                                CtlShowControl(cbProfileMuteVibrateONP);
                                                CtlShowControl(cbProfileMuteVibrateOFFP);
                                                soundPrefsP = &settingP->profiles[i].phoneSoundPrefs;
                                                break;
                                            case 1:     //
                                                CtlShowControl(cbProfileVibrateONP);
                                                CtlShowControl(cbProfileVibrateOFFP);
                                                CtlShowControl(cbProfileMuteVibrateONP);
                                                CtlShowControl(cbProfileMuteVibrateOFFP);
                                                soundPrefsP = &settingP->profiles[i].calendarSoundPrefs;
                                                break;
                                            case 2:     //Ѷ
                                                CtlShowControl(cbProfileVibrateONP);
                                                CtlShowControl(cbProfileVibrateOFFP);
                                                CtlShowControl(cbProfileMuteVibrateONP);
                                                CtlShowControl(cbProfileMuteVibrateOFFP);
                                                soundPrefsP = &settingP->profiles[i].smsSoundPrefs;
                                                break;
                                        }

                                        LstSetSelection(lstProfileVolumeP, soundPrefsP->soundOnVolume);
                                        CtlSetLabel(ptriProfileVolumeP, LstGetSelectionText(lstProfileVolumeP, soundPrefsP->soundOnVolume));

                                        if (soundPrefsP->soundOnVibrate)
                                        {
                                            CtlSetValue(cbProfileVibrateONP, 1);
                                            CtlSetValue(cbProfileVibrateOFFP, 0);
                                        }
                                        else
                                        {
                                            CtlSetValue(cbProfileVibrateONP, 0);
                                            CtlSetValue(cbProfileVibrateOFFP, 1);
                                        }
                                        if (soundPrefsP->soundOffVibrate)
                                        {
                                            CtlSetValue(cbProfileMuteVibrateONP, 1);
                                            CtlSetValue(cbProfileMuteVibrateOFFP, 0);
                                        }
                                        else
                                        {
                                            CtlSetValue(cbProfileMuteVibrateONP, 0);
                                            CtlSetValue(cbProfileMuteVibrateOFFP, 1);
                                        }
                                    }
                                    break;
                                case ptriProfileVolume:
                                    if (event.data.popSelect.selection != noListSelection)
                                    {
                                        i = LstGetSelection(lstProfileManagementP);
                                        if (i != noListSelection)
                                        {
                                            switch (LstGetSelection(lstProfileRingTypeP))
                                            {
                                                case 0:     //绰
                                                    //soundPrefsP = &settingP->profiles[i].phoneSoundPrefs;
                                                    settingP->profiles[i].phoneSoundPrefs.soundOnVolume = event.data.popSelect.selection;
                                                    break;
                                                case 1:     //
                                                    //soundPrefsP = &settingP->profiles[i].calendarSoundPrefs;
                                                    settingP->profiles[i].calendarSoundPrefs.soundOnVolume = event.data.popSelect.selection;
                                                    break;
                                                case 2:     //Ѷ
                                                    //soundPrefsP = &settingP->profiles[i].smsSoundPrefs;
                                                    settingP->profiles[i].smsSoundPrefs.soundOnVolume = event.data.popSelect.selection;
                                                    break;
                                            }
                                            //soundPrefsP->soundOnVolume = event.data.popSelect.selection;
                                        }
                                    }
                                    break;
                            }
                            break;
                        case ctlSelectEvent:
                            if (event.data.ctlSelect.controlID == btnProfileManagementOK)
                            {
                                shouldExit = true;
                            }
                            else
                            {
                                i = LstGetSelection(lstProfileManagementP);
                                if (i != noListSelection)
                                {
                                    switch (LstGetSelection(lstProfileRingTypeP))
                                    {
                                        case 0:     //绰
                                            soundPrefsP = &settingP->profiles[i].phoneSoundPrefs;
                                            break;
                                        case 1:     //
                                            soundPrefsP = &settingP->profiles[i].calendarSoundPrefs;
                                            break;
                                        case 2:     //Ѷ
                                            soundPrefsP = &settingP->profiles[i].smsSoundPrefs;
                                            break;
                                    }

                                    switch(event.data.ctlSelect.controlID)
                                    {
                                        case cbProfileVibrateON:
                                            if (CtlGetValue(cbProfileVibrateONP))
                                            {
                                                CtlSetValue(cbProfileVibrateOFFP, 0);
                                            }
                                            else
                                            {
                                                CtlSetValue(cbProfileVibrateOFFP, 1);
                                            }
                                            break;
                                        case cbProfileVibrateOFF:
                                            if (CtlGetValue(cbProfileVibrateOFFP))
                                            {
                                                CtlSetValue(cbProfileVibrateONP, 0);
                                            }
                                            else
                                            {
                                                CtlSetValue(cbProfileVibrateONP, 1);
                                            }
                                            break;
                                        case cbProfileMuteVibrateON:
                                            if (CtlGetValue(cbProfileMuteVibrateONP))
                                            {
                                                CtlSetValue(cbProfileMuteVibrateOFFP, 0);
                                            }
                                            else
                                            {
                                                CtlSetValue(cbProfileMuteVibrateOFFP, 1);
                                            }
                                            break;
                                        case cbProfileMuteVibrateOFF:
                                            if (CtlGetValue(cbProfileMuteVibrateOFFP))
                                            {
                                                CtlSetValue(cbProfileMuteVibrateONP, 0);
                                            }
                                            else
                                            {
                                                CtlSetValue(cbProfileMuteVibrateONP, 1);
                                            }
                                            break;
                                    }
                                    soundPrefsP->soundOnVibrate = CtlGetValue(cbProfileVibrateONP);
                                    soundPrefsP->soundOffVibrate = CtlGetValue(cbProfileMuteVibrateONP);
                                }
                            }
                            break;
                        case keyDownEvent:
                            if ((event.data.keyUp.keyCode >= keyA && event.data.keyUp.keyCode <= keyZ) ||
                                event.data.keyUp.keyCode == keySpace || event.data.keyUp.chr == keyZero || event.data.keyUp.chr == keyBackspace)
                            {
                                isEventHandled = FldHandleEvent(fldProfileNameP, &event);

                                if (isEventHandled)
                                {
                                    FldSendChangeNotification(fldProfileNameP);
                                }
                            }
                            break;
                    }

                    if (! isEventHandled)
                    {
                        FrmDispatchEvent(&event);
                    }
                }
            }while (event.eType != appStopEvent && shouldExit != true);

            if (profileNamePP != NULL)
            {
                for (i = 0; i < 5; i ++)
                {
                    if (profileNamePP[i] != NULL)
                        MemPtrFree(profileNamePP[i]);
                }
                MemPtrFree(profileNamePP);
            }

            //ˢ龰ģʽ
#if 0
            for (i = soundPrefTypePhone; i < soundPrefTypeLast; i ++)
            {
                TonesLibGetSoundPrefs(tonesLibRef, i, &soundPrefs);

                switch (i)
                {
                    case soundPrefTypePhone:
                        soundPrefs.soundOnVolume = settingP->profiles[settingP->lastProfile].phoneSoundPrefs.soundOnVolume;
                        soundPrefs.soundOnVibrate = settingP->profiles[settingP->lastProfile].phoneSoundPrefs.soundOnVibrate;
                        soundPrefs.soundOffVibrate = settingP->profiles[settingP->lastProfile].phoneSoundPrefs.soundOffVibrate;
                        break;
                    case soundPrefTypeEmail:
                        break;
                    case soundPrefTypeCalendar:
                        soundPrefs.soundOnVolume = settingP->profiles[settingP->lastProfile].calendarSoundPrefs.soundOnVolume;
                        soundPrefs.soundOnVibrate = settingP->profiles[settingP->lastProfile].calendarSoundPrefs.soundOnVibrate;
                        soundPrefs.soundOffVibrate = settingP->profiles[settingP->lastProfile].calendarSoundPrefs.soundOffVibrate;
                        break;
                    case soundPrefTypeIM:
                        break;
                    case soundPrefTypeMMS:
                        break;
                    case soundPrefTypeSMS:
                        soundPrefs.soundOnVolume = settingP->profiles[settingP->lastProfile].smsSoundPrefs.soundOnVolume;
                        soundPrefs.soundOnVibrate = settingP->profiles[settingP->lastProfile].smsSoundPrefs.soundOnVibrate;
                        soundPrefs.soundOffVibrate = settingP->profiles[settingP->lastProfile].smsSoundPrefs.soundOffVibrate;
                        break;
                }

                TonesLibSetSoundPrefs(tonesLibRef, i, &soundPrefs);
            }
#endif
            FrmReturnToForm(0);
        }

        TonesLibClose(tonesLibRef);
    }
    else
    {
        FrmCustomAlert(alertError, STRING_TONES_LIBRARY_ERROR, "", "");
    }
}