typedef struct
{
    UInt16      cardNo;
    LocalID     dbId;
    void        *next;
}DeleteListType;

#define SIGNAL_ONLY_LENGTH          (13)
#define SIGNAL_LEVEL_LENGTH         (3)
#define SIGNAL_DATA_LENGTH          (8)
#define SIGNAL_CONNECTION_LENGTH    (10)
#define BATTERY_SHAPE_LENGTH        (8)

extern WinLineType signalOnly[SIGNAL_ONLY_LENGTH];
extern WinLineType signalLevel[4][SIGNAL_LEVEL_LENGTH];
extern WinLineType signalData[SIGNAL_DATA_LENGTH];
extern WinLineType signalConnection[SIGNAL_CONNECTION_LENGTH];
extern WinLineType batteryShape[BATTERY_SHAPE_LENGTH];

extern void showSettingUI(SettingType *settingP, GlobeType *globeP);
extern void programManagement(GlobeType *globeP, UInt8 type, SettingType *settingP);
extern void profileManagement(SettingType *settingP, Boolean shouldGetDefaultSetting);
extern void freePluginList(PluginListType *pluginListP, UInt16 pluginListCount);
extern void getPluginList(PluginListType **pluginListPP, UInt16 *pluginListCount, Boolean isActivedOnly, GlobeType *globeP);
extern void getProgramName(UInt32 type, UInt32 creatorId, Char *nameP);
extern Err getDatabaseNameByTypeCreator(UInt32 type, UInt32 creatorId, Char *nameP);
extern void notifyRegister(SettingType *settingP/*, Boolean shouldSetVirtualCharHandlingNotify*/);
void notifyUnregister(SettingType *settingP/*Boolean shouldSetVirtualCharHandlingNotify*/);
extern WChar customKey();
extern WChar keyTransfer(WChar chr, UInt16 keyCode, UInt16 modifiers);
extern void getDefaultColor(SettingType *settingP);
extern void getGrayColor(RGBColorType *grayColor, RGBColorType *originalColor);
extern void getInvertColor(RGBColorType *invertColor, RGBColorType *originalColor);